@echo off

setlocal

REM  Copyright (C) 2005-2007 FUNAMBOL.
REM
REM  instructions:
REM  - set the JAVA_HOME
REM  - set the path for the JDBC driver
REM
REM

set CURRENT_DIR=%cd%
echo CURRENT_DIR: "%CURRENT_DIR%"
set INBOXLISTENER_HOME=%CURRENT_DIR%
if exist "%INBOXLISTENER_HOME%\bin\inboxlistener.cmd" goto okHome
cd ..
set INBOXLISTENER_HOME=%cd%


:okHome

REM to be defined
REM -------------
set JAVA_HOME=%INBOXLISTENER_HOME%\..\tools\jre-1.5.0\jre
set JDBC_JAR=
set JMX_PORT=4099


REM classpath
REM ---------
set IL_LIB=%INBOXLISTENER_HOME%\lib\funambol-framework.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\funambol-server.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\{funambol-ext.jar}
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\commons-dbcp-1.2.1.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\commons-discovery-0.4.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\commons-lang-2.2.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\commons-logging-1.1.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\commons-pool-1.3.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\commons-codec-1.3.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\axis.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\jaxrpc.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\log4j-1.2.14.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\saaj.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\wsdl4j-1.5.1.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\mail.jar
set IL_LIB=%IL_LIB%;%INBOXLISTENER_HOME%\lib\activation.jar

set IL_JAR=%INBOXLISTENER_HOME%\lib\funambol-inboxlistener-{ver_major}.{ver_minor}.{ver_build}.jar

set CLASSPATH=%IL_LIB%;%IL_JAR%;%JDBC_JAR%;%LOG_DIR%


if ""%1"" == ""start""    goto doStart
if ""%1"" == ""status""   goto doStatus
if ""%1"" == ""stop""     goto doStop
if ""%1"" == ""console""  goto doConsole


echo Usage:  inboxlistener ( commands ... )
echo commands:
echo   start           Start InboxListener
echo   start -debug    Start InboxListener with output console
echo   stop            Stop  InboxListener
echo   console         Start InboxListener Console
echo   status          Show  InboxListener status
goto END


:doStart

REM jdk
REM ---------
if ""%2"" == ""-debug"" (
    set EXEC=start "Inbox Listener" "%JAVA_HOME%\bin\java.exe"
) else (
    set EXEC=start "Inbox Listener" "%JAVA_HOME%\bin\javaw.exe"
)
REM class
REM ---------
set CLASS_NAME=com.funambol.email.inboxlistener.engine.MessageProcessor
REM options
REM ---------
set JAVA_OPTS=-Dfunambol.inboxlistener.home="%INBOXLISTENER_HOME%"
set JAVA_OPTS=%JAVA_OPTS% -Djava.library.path="%INBOXLISTENER_HOME%\lib\win32" 
rem Uncomment the following line to enable remote Debug
rem set JAVA_OPTS=%JAVA_OPTS% -Xdebug -Xrunjdwp:transport=dt_socket,address=8788,server=y,suspend=y
set JAVA_OPTS=%JAVA_OPTS% -Dcom.sun.management.jmxremote -Dcom.sun.management.jmxremote.port=%JMX_PORT% -Dcom.sun.management.jmxremote.ssl=false -Dcom.sun.management.jmxremote.authenticate=false

goto CONT1


:doStop

REM jdk
REM ---------
set EXEC="%JAVA_HOME%\bin\java.exe"
REM class
REM ---------
set CLASS_NAME=com.funambol.email.inboxlistener.engine.ManagementTools
REM arguments
REM ---------
set ARGS=localhost %JMX_PORT% stop

goto CONT1

:doStatus

REM jdk
REM ---------
set EXEC="%JAVA_HOME%\bin\java.exe"
REM class
REM ---------
set CLASS_NAME=com.funambol.email.inboxlistener.engine.ManagementTools
REM arguments
REM ---------
set ARGS=localhost %JMX_PORT% status

goto CONT1

:doConsole

REM jdk
REM ---------
set EXEC="%JAVA_HOME%\bin\java.exe"
REM class
REM ---------
set CLASS_NAME=com.funambol.email.inboxlistener.console.Menu
REM options
REM ---------
set JAVA_OPTS=-Dfunambol.inboxlistener.home="%INBOXLISTENER_HOME%"
set JAVA_OPTS=%JAVA_OPTS% -Djava.library.path="%INBOXLISTENER_HOME%\lib\win32"

goto CONT1


:CONT1

REM run INBOXLISTENER
REM -----------------

echo HOME: "%INBOXLISTENER_HOME%"
echo CLASSPATH: "%CLASSPATH%"
echo JAVA_OPTS: %JAVA_OPTS%

%EXEC% %JAVA_OPTS% -classpath "%CLASSPATH%" %CLASS_NAME% %ARGS%

cd %CURRENT_DIR%

:END

endlocal
