/**
 * Copyright (C) 2005-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.admin;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.Serializable;

import com.funambol.admin.config.AdminConfig;
import com.funambol.admin.util.Log;
import com.funambol.admin.ui.ConnectorManagementPanel;

import com.funambol.email.admin.dao.WSDAO;
import com.funambol.email.engine.source.EmailConnectorConfig;
import com.funambol.email.admin.mailservers.SearchMailServerPanel;
import javax.swing.JPanel;

/**
 * This class acts as the entry point for the email connector component admin
 * tool.
 *
 * @version $Id: ConsolePanel.java,v 1.12 2007/03/19 16:17:14 gbmiglia Exp $
 */
public class ConsolePanel
        extends ConnectorManagementPanel
        implements Serializable, ActionListener
        
{
    
    // ------------------------------------------------------------ Private data
    
    private SearchAccountPanel searchAccountPanel;
    private SearchMailServerPanel searchMailServerPanel;
    
    private AccountController accountController;
    private WSDAO WSDao;
    
    // ------------------------------------------------------------ Constructors
    
    public ConsolePanel() {
        try {
            initWSDao();
            accountController = new AccountController(true);
            initGui();
            searchMailServerPanel.addObserver(searchAccountPanel);        
            
        } catch (Exception e) {
            Log.error("Error initializing ConsolePanel", e);
        }
    }
    
    // --------------------------------------------------------- Private methods
    
    /**
     * Create the panel.
     */
    private void initGui() {
        
        //
        // Mail server section.
        //
        
        searchMailServerPanel = new SearchMailServerPanel();
        searchMailServerPanel.setWSDao(WSDao);
        searchMailServerPanel.setBounds(new Rectangle(14, 5, 700, 200));

        //
        // Accounts section.
        // Pass the controller to account panel
        //
        searchAccountPanel = new SearchAccountPanel(accountController);
        searchAccountPanel.setBounds(new Rectangle(14, 205, 700, 380));
                
        setLayout(null);
        add(searchMailServerPanel);
        add(searchAccountPanel);
    }
    
    /**
     * Set preferredSize of the panel
     *
     * @return preferredSize of the panel
     */
    public Dimension getPreferredSize() {
        return new Dimension(525, 650);
    }
    
    /**
     *
     */
    public void updateForm() {
        
        EmailConnectorConfig emailConf = (EmailConnectorConfig) getConfiguration();
        
        
    }
    
    public void actionPerformed(ActionEvent actionEvent) {
        super.actionPerformed(actionEvent);
    }
    
    // ----------------------------------------------------------- Private methods
    
    /**
     * Checks if the values provided by the user are all valid. In caso of errors,
     * a IllegalArgumentException is thrown.
     *
     * @throws IllegalArgumentException if:
     *                                  <ul>
     *                                  <li>anyvalue is not in the form <host>:<port>
     *                                  </ul>
     */
    private void validateValues() throws IllegalArgumentException {
        String value;        
    }
    
    /**
     * Set properties with the values provided by the user.
     */
    private void getValues() {        
        EmailConnectorConfig emailConf = (EmailConnectorConfig) getConfiguration();
    }
    
    private void initWSDao() throws Exception {
        
        String endPoint = "";
        String user = "";
        String pwd = "";
        int reloadingTime = 0;        
        
        StringBuilder sb = new StringBuilder();
        sb.append("http://")
            .append(AdminConfig.getAdminConfig().getHostName())
            .append(':')
            .append(AdminConfig.getAdminConfig().getServerPort())
            .append(AdminConfig.getAdminConfig().getContextPath())
            .append("/services/email");
        endPoint = sb.toString();
        
        user = AdminConfig.getAdminConfig().getUser();
        pwd = AdminConfig.getAdminConfig().getPassword();
        reloadingTime = 1;
        
        WSDao = new WSDAO(endPoint, user, pwd);        
    }

}
