/**
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */

package com.funambol.email.admin;

/**
 * Enumeration class to represent account process types.
 *
 * @version $Id: OperationType.java,v 1.2 2007/01/23 10:01:05 piter_may Exp $
 */
public class OperationType {
    
    // --------------------------------------------------------------- Constants
    
    public static final OperationType ACCOUNT_INSERTION = new OperationType("account insertion");
    public static final OperationType ACCOUNT_UPDATE = new OperationType("account update");
    public static final OperationType MAILSERVER_INSERTION = new OperationType("mail server insertion");
    public static final OperationType MAILSERVER_UPDATE = new OperationType("mail server update");

    // ------------------------------------------------------------ Private data
    
    private String description;
    
    // ------------------------------------------------------------ Constructors
    
    /** Creates a new instance of OperationType */
    private OperationType(String description) {
        this.description = description;
    }
    
}
