/**
 * Copyright (C) 2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */

package com.funambol.email.admin;

import java.util.ArrayList;

/**
 * Class that represent errors collected during validation of data in a panel. 
 * 
 * 
 * @version $Id: ValidationError.java,v 1.1 2007/01/23 10:01:05 piter_may Exp $
 */
public class ValidationError {
    
    // -------------------------------------------------------------- Properties
    
    /** array of error messages */
    private ArrayList<String> errorStrings;

    /**
     * Gets the array of the error messages.
     *
     * @return array of the error messages
     */
    public ArrayList<String> getErrorStrings(){
        return errorStrings;
    }

    // ------------------------------------------------------------ Constructors
    
    /**
     * Creates a new instance of ValidationError
     */
    public ValidationError() {
        this.errorStrings = new ArrayList<String>();
    }
    
    // ---------------------------------------------------------- Public methods
    
    /**
     * Adds an erorr message.
     *
     * @param errorString error message
     */
    public void addErrorString(String errorString){
        this.errorStrings.add(errorString);
    }
}
