/**
 * Copyright (C) 2005-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.engine.source;


import com.funambol.server.config.Configuration;
import com.funambol.framework.tools.beans.BeanException;
import com.funambol.framework.tools.beans.BeanInstantiationException;
import com.funambol.framework.tools.beans.BeanInitializationException;
import com.funambol.framework.tools.beans.BeanNotFoundException;

import com.funambol.email.exception.EmailConfigException;


/**
 * This class loads the parameter from the XML configuration file
 *
 * @version $Id: EmailConnectorConfig.java,v 1.4 2007/01/30 08:16:31 gbmiglia Exp $
 */
public class EmailConnectorConfig {

    // --------------------------------------------------------------- CONSTANTS

    /**     */
    public final static String beanName = "email/email/FunambolEmailConnector.xml";

    // -------------------------------------------------------------- PROPERTIES

    /**
     * keystore path
     */
    private String keystoreHome;
        
    /**
     * datasource
     */
    private String dataSource;

    /**
     * 
     */
    private boolean saveOnlyHeader;
    
    //------------------------------------------------------------- CONSTRUCTORS

    /**
     *
     */
    public EmailConnectorConfig() {
    }

    //----------------------------------------------------------- PUBLIC METHODS

    /**
     * @return EmailConnectorConfig
     * @throws EmailConfigException
     */
    public static EmailConnectorConfig getConfigInstance()
            throws EmailConfigException {

        EmailConnectorConfig emailConf;
        try {
            emailConf = 
                 (EmailConnectorConfig) Configuration.getConfiguration().getBeanInstanceByName(beanName);
        } catch (BeanInstantiationException bie) {
            throw new EmailConfigException(bie.getMessage());
        } catch (BeanInitializationException bie) {
            throw new EmailConfigException(bie.getMessage());
        } catch (BeanNotFoundException bie) {
            throw new EmailConfigException(bie.getMessage());
        } catch (BeanException be) {
            throw new EmailConfigException(be.getMessage());
        }

        return emailConf;

    }



    /**
     * @param _keystoreHome String
     */
    public void setKeystoreHome(String _keystoreHome) {
        this.keystoreHome = _keystoreHome;
    }

    /**
     * @return keystoreHome String
     */
    public String getKeystoreHome() {
        return this.keystoreHome;
    }

    /**
     * @param _dataSource String
     */
    public void setDataSource(String _dataSource) {
        this.dataSource = _dataSource;
    }

    /**
     * @return dataSource
     */
    public String getDataSource() {
        return this.dataSource;
    }
    
    /**
     * @param _saveOnlyHeader String
     */
    public void setSaveOnlyHeader(boolean _saveOnlyHeader) {
        this.saveOnlyHeader = _saveOnlyHeader;
    }

    /**
     * @return saveOnlyHeader
     */
    public boolean getSaveOnlyHeader() {
        return this.saveOnlyHeader;
    }
    
}
