/**
 * Copyright (C) 2005-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.engine.source;


import com.funambol.email.util.Def;
import com.funambol.framework.engine.source.SyncSourceException;


/**
 * 
 * 
 * 
 * 
 * 
 * @version $Id: EmailFactory.java,v 1.2 2007/01/15 16:37:39 nichele Exp $
 */
public class EmailFactory {


  /**
   *
   */
   public static IEmailGeneric getEmailSyncSource(String p, EmailSyncSourceWrapper essc) 
     throws SyncSourceException {

        IEmailGeneric ess = null;

        try {
            if      (p.equals(Def.PROTOCOL_IMAP)){
              ess = new EmailImap(essc);
            }
            else if (p.equals(Def.PROTOCOL_POP3)){
              ess =  new EmailPop(essc);
            } else {
                throw new SyncSourceException("Error getting interface ");            
            }
        } catch (SyncSourceException sse) {
            throw new SyncSourceException("Error getting interface: " + sse.getMessage());            
        }

        return ess;
    }

}
