/**
 * Copyright (C) 2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.exception;

/**
 * Exception used in the sending procedure
 *
 * @version $Id: SendingException.java,v 1.4 2007/01/30 17:22:07 gbmiglia Exp $
 */
public class SendingException extends Exception {

    /**
     * Creates a new instance of <code>SendingException</code> without
     * detail message.
     */
    public SendingException() {

    }

    /**
     * Constructs an instance of <code>SendingException</code> with the
     * specified detail message.
     *
     * @param msg the detail message.
     */
    public SendingException(String msg) {
        super(msg);
    }

    /**
     * Constructs an instance of <code>SendingException</code> with the
     * specified exception.
     *
     * @param cause Throwable
     */
    public SendingException(Throwable cause) {
        super(cause);
    }

    /**
     * Constructs an instance of <code>SendingException</code> with the
     * specified detail message.
     *
     * @param msg String
     * @param cause Throwable
     */
    public SendingException(String msg, Throwable cause) {
        super(msg, cause);
    }

}
