/**
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.inboxlistener.console;


import com.funambol.email.exception.InboxListenerConfigException;
import com.funambol.email.exception.InboxListenerException;
import com.funambol.email.inboxlistener.admin.InboxListenerConfig;
import com.funambol.email.inboxlistener.engine.MSTools;
import com.funambol.email.inboxlistener.engine.WSAccount;
import com.funambol.email.model.MailServerAccount;
import com.funambol.email.util.UtilityIL;
import com.funambol.email.transport.IMailServerWrapper;
import com.funambol.email.transport.MailServerWrapperFactory;
import javax.mail.Folder;
import javax.mail.MessagingException;
import com.sun.mail.imap.IMAPFolder;
import java.util.ArrayList;
import javax.mail.NoSuchProviderException;


/**
 * <p>this class implements the methods to get the Folders in a specific
 * mailbox</p>
 *
 * @version $Id: FolderManager.java,v 1.6 2007/01/15 16:47:08 gbmiglia Exp $
 */

public class FolderManager
{
    
                
  //--------------------------------------------------------------- Constructors
    
  public FolderManager() {
  }

  //------------------------------------------------------------- Public Methods
      
  /**
   *
   */
  public void imapFolderList(MailServerAccount msa) throws InboxListenerException {
          
     try {
                   
          IMailServerWrapper mswf = 
                  MailServerWrapperFactory.getMailServerWrapper(msa.getMailServer().getProtocol());
                   
          MSTools mstools = new MSTools(msa);
         
          mstools.openConnection (mswf);
          
          ArrayList fs = new ArrayList();         
          
          IMAPFolder folder = (IMAPFolder) mswf.getStore().getDefaultFolder();
          
          searchSubFolder(folder, fs);
          
          System.out.println("IMAP Folders in the Account " + msa.getUsername());
          for (int i = 0; i < fs.size(); i++) {
             System.out.println(fs.get(i));
          }          
          
          mstools.closeConnection(mswf);            
                            
     } catch (NoSuchProviderException ex) {
         throw new InboxListenerException("Error opening Account - Check the protocol");
     } catch (MessagingException ex) {
         throw new InboxListenerException("Error connecting Account - Check the user");
     }
     

  }
  
  //------------------------------------------------------------- Private Methods
  
  /**
   *
   * @param folder IMAPFolder
   * @throws MessagingException
   */
  private static void searchSubFolder(IMAPFolder folder, ArrayList fs) 
    throws MessagingException {
      
      Folder[] folderList = folder.list();
      
      IMAPFolder f;
      String s = "";
      for (int i = 0; i < folderList.length; i++) {
          f = ((IMAPFolder) folderList[i]);
          s = "folder name: " + f.getName() + " - full name: " + f.getFullName();
          fs.add(s);
          searchSubFolder(f, fs);
      }
      
  }
  
  
}
