/**
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.inboxlistener.console;



import com.funambol.email.exception.InboxListenerException;
import com.funambol.email.exception.InboxListenerConfigException;
import com.funambol.email.inboxlistener.admin.InboxListenerConfig;
import com.funambol.email.model.MailServer;
import com.funambol.email.model.MailServerAccount;
import com.funambol.email.model.SyncItemInfoAdmin;
import com.funambol.email.util.Utility;
import com.funambol.email.util.UtilityIL;

/**
 * simple admin console
 *
 * @version $Id: Menu.java,v 1.28 2007/02/05 13:30:37 gbmiglia Exp $
 */
public class Menu {

  private MenuWSDAO menuWSDAO = null;

  /**
   *
   */
  public Menu() {
     go();
  }

  /**
   *
   */
  public static void main(String[] args) {
     Menu m = new Menu();
  }


  /**
   *
   */
  public void go(){

     // load DataBase Properties
     String endPoint      = "";
     String user          = "";
     String pwd           = "";
     int    reloadingTime = 0;
     try {
         endPoint      = InboxListenerConfig.getConfigInstance().getWsEndPoint();
         user          = InboxListenerConfig.getConfigInstance().getWsUsername();
         pwd           = InboxListenerConfig.getConfigInstance().getWsPassword();
         reloadingTime = InboxListenerConfig.getConfigInstance().getReloadingTime();
         //
         menuWSDAO = new MenuWSDAO(endPoint,user,pwd);
     } catch (InboxListenerConfigException e) {
         e.printStackTrace();
     } catch (InboxListenerException e) {
         e.printStackTrace();
     }

     try {
        // clean display
        for (int p=0;p<50;p++)
          System.out.println("");

        int option = -1;

        while (true) {
          option = mainMenu();
          if (option == 0) {
            break;
          }
        }
     }
     catch(java.lang.Exception e) {
        e.printStackTrace();
     }

  }



  /**
   *
   */
  public int mainMenu()
  {
    String option = null;
    int value = -1;

    try {
       System.out.println("");
       System.out.println("");
       System.out.println(" INBOX LISTENER ACCOUNT CONSOLE");
       System.out.println("");
       System.out.println(" 0    quit");
       System.out.println("");
       System.out.println(" 11   list accounts");
       System.out.println(" 12   get account");
       System.out.println(" 13   insert account");
       System.out.println(" 14   delete account");
       System.out.println(" 15   disable account");
       System.out.println(" 16   enable account");
       System.out.println(" 17   update account");
       System.out.println(" 18   check account");
       System.out.println(" 19   get cached info");
       System.out.println("");
       System.out.println(" 21   list public mail servers");
       System.out.println(" 22   get public mail server");
       System.out.println(" 23   insert public mail server");
       System.out.println(" 24   delete public mail server");
       System.out.println(" 25   update public mail server");
       System.out.println("");
       System.out.println(" 31   IMAP Folder for account");
       System.out.println(" ");

       value = UtilityIL.readInteger();

       switch (value) {
        case 11: listAccounts();   break;
        case 12: getAccount();     break;
        case 13: insertAccount();  break;
        case 14: deleteAccount();  break;
        case 15: disableAccount(); break;
        case 16: enableAccount();  break;
        case 17: updateAccount();  break;
        case 18: checkAccount();    break;
        case 19: getCachedInfo();    break;
        
        case 21: listServers();    break;
        case 22: getServer();      break;
        case 23: insertServer();   break;
        case 24: deleteServer();   break;
        case 25: updateServer();   break;
        
        case 31: imapFolder();      break;
        
        case 0: break;
        default: System.out.println("error");
         return 0;
       }
      } catch(java.lang.Exception e){
        e.printStackTrace();
        return 0;
      }
      return value;
   }


  //------------------------------------------------------------ PRIVATE METHODS


  /**
   *
   */
  private void listAccounts() throws InboxListenerException {
     try {
         
        MailServerAccount[] l = menuWSDAO.getAccounts();
        
        if (l != null) {
          if (l.length == 0){
            System.out.println("No accounts found");
          }
          for (int i=0; i < l.length; i++){
            System.out.println(l[i].toStringForCommandLine());
          }
        } else {
          System.out.println("No accounts found");
        }
     } catch (Exception ex) {
        throw new InboxListenerException("Error reading accounts (" +
                                          ex.getMessage() + ")");
     }
  }

  /**
   *
   */
  private void listServers() throws InboxListenerException {
     try {
         
        MailServer[] l = menuWSDAO.getMailServers();
        
        if (l != null) {
          if (l.length == 0){
            System.out.println("No public mail servers found");
          }
          for (int i=0; i < l.length; i++){
            System.out.println(l[i].toStringForCommandLine());
          }
        } else {
          System.out.println("No servers found");
        }
     } catch (Exception ex) {
        throw new InboxListenerException("Error reading servers (" +
                                          ex.getMessage() + ")");
     }
  }
  
  /**
   *
   */
  private void getAccount() throws InboxListenerException {
     try {
         
       System.out.print("Username: ");
       String username = UtilityIL.readValue();
         
        MailServerAccount msa = menuWSDAO.getAccount(username);
        
        if (msa != null) {
           System.out.println(msa.toStringForCommandLine());
        } else {
           System.out.println("Account not found");
        }
        
     } catch (Exception ex) {
        throw new InboxListenerException("Error getting account (" +
                                          ex.getMessage() + ")");
     }
  }  

  /**
   *
   */
  private void getCachedInfo() throws InboxListenerException {
     try {
         
       System.out.print("Username: ");
       String username = UtilityIL.readValue();
       System.out.print("Protocol: ");
       String protocol = UtilityIL.readValue();
         
        SyncItemInfoAdmin[] info   = menuWSDAO.getCachedInfo(username, protocol);
        SyncItemInfoAdmin record = null;
        
        if (info != null) {
            for (int i=0; i< info.length; i++){
                record = (SyncItemInfoAdmin)info[i];
                System.out.println(record.toString());
            }
        } else {
           System.out.println("NO DATA");
        }
        
     } catch (Exception ex) {
        throw new InboxListenerException("Error getting cached info (" +
                                          ex.getMessage() + ")");
     }
  }  
  
  
  /**
   *
   */
  private void getServer() throws InboxListenerException {
     try {
         
       System.out.print("Mail Server ID: ");
       String serverID = UtilityIL.readValue();
         
        MailServer ms = menuWSDAO.getMailServerFromID(serverID);
        
        if (ms != null) {
           System.out.println(ms.toStringForCommandLine());
        } else {
           System.out.println("Mail Server not found");
        }
        
     } catch (Exception ex) {
        throw new InboxListenerException("Error getting mail server (" +
                                          ex.getMessage() + ")");
     }
  }  
  
  /**
   *
   */
  private void insertAccount() throws InboxListenerException {
     try {
              
       // get Mail Server
       MailServer[] msl = menuWSDAO.getMailServers();
       System.out.println("Server List");
       for (int i=0; i<msl.length; i++){
           System.out.println(msl[i].getMailServerId() + " - " + 
                              msl[i].getDescription());
       }
         
       System.out.print("username: ");
       String username = UtilityIL.readValue();
       
       System.out.print("MS login: ");
       String msLogin = UtilityIL.readValue();
       System.out.print("MS address: ");
       String msAddress = UtilityIL.readValue();
       System.out.print("MS password: ");
       String msPassword = UtilityIL.readValue();
       
       System.out.print("activation (y/n): ");
       String active = UtilityIL.readValue();
       System.out.print("push (y/n): ");
       String push = UtilityIL.readValue();
       System.out.print("refresh time (min.): ");
       String refreshTime = UtilityIL.readValue();
       
       System.out.print("listener id (number): ");
       String listenerID = UtilityIL.readValue();
       
       System.out.print("Max Email Number in Cache (number): ");
       int maxEmailNum  = Integer.parseInt(UtilityIL.readValue());
       System.out.print("Max IMAP Email Number in Sent/Trash Folder (number): ");
       int maxEmailIMAP = Integer.parseInt(UtilityIL.readValue());
       
       System.out.print("public (y/n): ");
       String isPublic = UtilityIL.readValue();
       
       String serverID     = null;
       String serverType   = null;
       String description  = null;
       String protocol     = null;
       String isSoftDelete = null;
       String outServer    = null;
       String outPort      = null;
       String outAuth      = null;
       String inServer     = null;
       String inPort       = null;
       String isSSLIn      = null;
       String isSSLOut     = null;
       String keystorePath = null;
       String keystorePwd  = null;
       String outboxPath   = null;
       String outboxActive = null;
       String sentPath     = null;
       String sentActive   = null;
       String draftsPath   = null;
       String draftsActive = null;
       String trashPath    = null;
       String trashActive  = null;       
       
       if (isPublic.equalsIgnoreCase("y")){
           
           // just the ID
           System.out.print("Mail Server ID: ");
           serverID = UtilityIL.readValue();
           
           MailServer ms = this.getServerFromArray(msl, serverID);
           
           if (ms != null){
               MailServerAccount msa = new MailServerAccount();
               // account
               msa.setAccountId(null);   
               msa.setUsername(username);   
               msa.setMsLogin(msLogin);    
               msa.setMsPassword(msPassword); 
               msa.setMsAddress(msAddress); 
               msa.setListenerId(listenerID);  
               msa.setActivation(Utility.booleanFromString(active));
               msa.setPush(Utility.booleanFromString(push)); 
               msa.setRefreshTime(Integer.parseInt(refreshTime));
               msa.setMaxEmailNumber(maxEmailNum); 
               msa.setMaxImapEmail(maxEmailIMAP); 
               // mail server
               msa.setMailServer(ms);  
               //
               menuWSDAO.insertAccount(msa);
           }           
           
       } else {
           
           // all the info
           System.out.print("server type (Exchange/Courier/Other): ");
           serverType = UtilityIL.readValue();
           System.out.print("description: ");
           description = UtilityIL.readValue();
           System.out.print("protocol (imap/pop3): ");
           protocol = UtilityIL.readValue();
           System.out.print("soft delete (y/n): ");
           isSoftDelete = UtilityIL.readValue();

           System.out.print("Server Out: ");
           outServer = UtilityIL.readValue();
           System.out.print("Server Out Port: ");
           outPort = UtilityIL.readValue();
           System.out.print("server Out Authetication (y/n): ");
           outAuth = UtilityIL.readValue();
           System.out.print("Server In: ");
           inServer = UtilityIL.readValue();
           System.out.print("Server In Port: ");
           inPort = UtilityIL.readValue();

           System.out.print("SSL In (y/n): ");
           isSSLIn = UtilityIL.readValue();
           System.out.print("SSL Out (y/n): ");
           isSSLOut = UtilityIL.readValue();
           System.out.print("key path: ");
           keystorePath = UtilityIL.readValue();
           System.out.print("key pwd: ");
           keystorePwd = UtilityIL.readValue();

           System.out.print("Outbox Path: ");
           outboxPath = UtilityIL.readValue();
           System.out.print("Outbox Active (y/n): ");
           outboxActive = UtilityIL.readValue();
           System.out.print("Sent Path: ");
           sentPath = UtilityIL.readValue();
           System.out.print("Sent Active (y/n): ");
           sentActive = UtilityIL.readValue();
           System.out.print("Drafts Path: ");
           draftsPath = UtilityIL.readValue();
           System.out.print("Drafts Active (y/n): ");
           draftsActive = UtilityIL.readValue();
           System.out.print("Trash Path: ");
           trashPath = UtilityIL.readValue();
           System.out.print("Trash Active (y/n): ");
           trashActive = UtilityIL.readValue();
           
           MailServerAccount msa = new MailServerAccount();
           // account
           msa.setAccountId(null);   
           msa.setUsername(username);   
           msa.setMsLogin(msLogin);    
           msa.setMsPassword(msPassword); 
           msa.setMsAddress(msAddress); 
           msa.setListenerId(listenerID);  
           msa.setActivation(Utility.booleanFromString(active));
           msa.setPush(Utility.booleanFromString(push)); 
           msa.setRefreshTime(Integer.parseInt(refreshTime));
           msa.setMaxEmailNumber(maxEmailNum); 
           msa.setMaxImapEmail(maxEmailIMAP); 

           // mail server
           MailServer        ms  = new MailServer();
           ms.setMailServerId(serverID);                
           ms.setMailServerType(serverType); 
           ms.setDescription(description);   
           ms.setIsSoftDelete(Utility.booleanFromString(isSoftDelete)); 
           ms.setIsPublic(Utility.booleanFromString(isPublic)); 
           ms.setProtocol(protocol);      
           ms.setOutServer(outServer); 
           ms.setOutPort(Integer.parseInt(outPort)); 
           ms.setOutAuth(Utility.booleanFromString(outAuth)); 
           ms.setInServer(inServer); 
           ms.setInPort(Integer.parseInt(inPort)); 
           ms.setIsSSLIn(Utility.booleanFromString(isSSLIn)); 
           ms.setIsSSLOut(Utility.booleanFromString(isSSLOut)); 
           ms.setKeystorePath(keystorePath); 
           ms.setKeystorePwd(keystorePwd); 
           ms.setInboxPath("Inbox");  
           ms.setInboxActivation(Utility.booleanFromString("y")); 
           ms.setOutboxPath(outboxPath); 
           ms.setOutboxActivation(Utility.booleanFromString(outboxActive)); 
           ms.setSentPath(sentPath);   
           ms.setSentActivation(Utility.booleanFromString(sentActive)); 
           ms.setDraftsPath(draftsPath);   
           ms.setDraftsActivation(Utility.booleanFromString(draftsActive)); 
           ms.setTrashPath(trashPath);   
           ms.setTrashActivation(Utility.booleanFromString(trashActive)); 

           msa.setMailServer(ms);               

           menuWSDAO.insertAccount(msa);
           
       }       

     } catch (Exception ex) {
       throw new InboxListenerException("Error adding accounts (" +
                                         ex.getMessage() + ")");
     }
  }

  /**
   *
   */
  private void insertServer() throws InboxListenerException {
      
     try {
                                            
       System.out.print("public (y): ");
       String isPublic = UtilityIL.readValue();
       System.out.print("server type (Exchange/Courier/Other): ");
       String serverType = UtilityIL.readValue();
       System.out.print("description: ");
       String description = UtilityIL.readValue();
       System.out.print("protocol (imap/pop3): ");
       String protocol = UtilityIL.readValue();
       System.out.print("soft delete (y/n): ");
       String isSoftDelete = UtilityIL.readValue();

       System.out.print("Server Out: ");
       String outServer = UtilityIL.readValue();
       System.out.print("Server Out Port: ");
       String outPort = UtilityIL.readValue();
       System.out.print("server Out Authetication (y/n): ");
       String outAuth = UtilityIL.readValue();
       System.out.print("Server In: ");
       String inServer = UtilityIL.readValue();
       System.out.print("Server In Port: ");
       String inPort = UtilityIL.readValue();

       System.out.print("SSL In (y/n): ");
       String isSSLIn = UtilityIL.readValue();
       System.out.print("SSL Out (y/n): ");
       String isSSLOut = UtilityIL.readValue();
       System.out.print("key path: ");
       String keystorePath = UtilityIL.readValue();
       System.out.print("key pwd: ");
       String keystorePwd = UtilityIL.readValue();

       System.out.print("Outbox Path: ");
       String outboxPath = UtilityIL.readValue();
       System.out.print("Outbox Active (y/n): ");
       String outboxActive = UtilityIL.readValue();
       System.out.print("Sent Path: ");
       String sentPath = UtilityIL.readValue();
       System.out.print("Sent Active (y/n): ");
       String sentActive = UtilityIL.readValue();
       System.out.print("Drafts Path: ");
       String draftsPath = UtilityIL.readValue();
       System.out.print("Drafts Active (y/n): ");
       String draftsActive = UtilityIL.readValue();
       System.out.print("Trash Path: ");
       String trashPath = UtilityIL.readValue();
       System.out.print("Trash Active (y/n): ");
       String trashActive = UtilityIL.readValue();
           
       
       MailServer        ms  = new MailServer();

       ms.setMailServerId(null);                
       ms.setMailServerType(serverType); 
       ms.setDescription(description);   
       ms.setIsSoftDelete(Utility.booleanFromString(isSoftDelete)); 
       ms.setIsPublic(Utility.booleanFromString(isPublic)); 
       ms.setProtocol(protocol);      
       ms.setOutServer(outServer); 
       ms.setOutPort(Integer.parseInt(outPort)); 
       ms.setOutAuth(Utility.booleanFromString(outAuth)); 
       ms.setInServer(inServer); 
       ms.setInPort(Integer.parseInt(inPort)); 
       ms.setIsSSLIn(Utility.booleanFromString(isSSLIn)); 
       ms.setIsSSLOut(Utility.booleanFromString(isSSLOut)); 
       ms.setKeystorePath(keystorePath); 
       ms.setKeystorePwd(keystorePwd); 
       ms.setInboxPath("Inbox");  
       ms.setInboxActivation(Utility.booleanFromString("y")); 
       ms.setOutboxPath(outboxPath); 
       ms.setOutboxActivation(Utility.booleanFromString(outboxActive)); 
       ms.setSentPath(sentPath);   
       ms.setSentActivation(Utility.booleanFromString(sentActive)); 
       ms.setDraftsPath(draftsPath);   
       ms.setDraftsActivation(Utility.booleanFromString(draftsActive)); 
       ms.setTrashPath(trashPath);   
       ms.setTrashActivation(Utility.booleanFromString(trashActive)); 

       menuWSDAO.insertMailServer(ms);

     } catch (Exception ex) {
       throw new InboxListenerException("Error adding accounts (" +
                                         ex.getMessage() + ")");
     }
     
  }

  
  /**
   *
   */
  private void updateAccount() throws InboxListenerException {
     try {
       
       // get Mail Server
       MailServer[] msl = menuWSDAO.getMailServers();
       System.out.println("Server List");
       for (int i=0; i<msl.length; i++){
           System.out.println(msl[i].getMailServerId() + " - " + 
                              msl[i].getDescription());
       }
         
       // get User Info
       System.out.print("user to be updated (id): ");
       String accountID = UtilityIL.readValue();
       MailServerAccount msaold  = menuWSDAO.getAccountFromID(accountID);
       MailServer msold = null;
       if (msaold != null){
           msold = msaold.getMailServer();
       }   
       
       if (msold != null){
           System.out.print("Account ID ("+msaold.getAccountId()+"): ");

           System.out.print("username ("+msaold.getUsername()+"): ");
           String username = UtilityIL.readValue();
           System.out.print("MS login ("+msaold.getMsLogin()+"): ");
           String msLogin = UtilityIL.readValue();
           System.out.print("MS address ("+msaold.getMsAddress()+"): ");
           String msAddress = UtilityIL.readValue();
           System.out.print("MS password ("+msaold.getMsPassword()+"): ");
           String msPassword = UtilityIL.readValue();
           System.out.print("activation (y/n) ("+msaold.getActivation()+"): ");
           String active = UtilityIL.readValue();
           System.out.print("push (y/n) ("+msaold.getPush()+"): ");
           String push = UtilityIL.readValue();
           System.out.print("refresh time (min.) ("+msaold.getRefreshTime()+"): ");
           String refreshTime = UtilityIL.readValue();
           System.out.print("listener id (number) ("+msaold.getListenerId()+"): ");
           String listenerID = UtilityIL.readValue();
           System.out.print("Max Email Number in Cache (number) ("+msaold.getMaxEmailNumber()+"): ");
           int maxEmailNum  = Integer.parseInt(UtilityIL.readValue());
           System.out.print("Max IMAP Email Number in Sent/Trash Folder (number) ("+msaold.getMaxImapEmail()+"): ");
           int maxEmailIMAP = Integer.parseInt(UtilityIL.readValue());


           System.out.print("public (y/n) ("+msold.getIsPublic()+"): ");
           String isPublic = UtilityIL.readValue();
           
           String serverID     = null;
           String serverType   = null;
           String description  = null;
           String protocol     = null;
           String isSoftDelete = null;
           String outServer    = null;
           String outPort      = null;
           String outAuth      = null;
           String inServer     = null;
           String inPort       = null;
           String isSSLIn      = null;
           String isSSLOut     = null;
           String keystorePath = null;
           String keystorePwd  = null;
           String outboxPath   = null;
           String outboxActive = null;
           String sentPath     = null;
           String sentActive   = null;
           String draftsPath   = null;
           String draftsActive = null;
           String trashPath    = null;
           String trashActive  = null;
           
           if (isPublic.equalsIgnoreCase("y")){
               
               // just the ID
               System.out.print("Mail Server ID ("+msold.getMailServerId()+"): ");
               serverID = UtilityIL.readValue();
               
               MailServerAccount msa = new MailServerAccount();

               // account
               msa.setAccountId(msaold.getAccountId());   
               msa.setUsername(username);   
               msa.setMsLogin(msLogin);    
               msa.setMsPassword(msPassword); 
               msa.setMsAddress(msAddress); 
               msa.setListenerId(listenerID);  
               msa.setActivation(Utility.booleanFromString(active));
               msa.setPush(Utility.booleanFromString(push)); 
               msa.setRefreshTime(Integer.parseInt(refreshTime));
               msa.setMaxEmailNumber(maxEmailNum); 
               msa.setMaxImapEmail(maxEmailIMAP); 
               
               MailServer ms = this.getServerFromArray(msl, serverID);

               // mail server
               msa.setMailServer(ms);  
               
               //
               menuWSDAO.updateAccount(msa);
               
           } else {
               
               System.out.print("server type (Exchange/Courier/Other) ("+msold.getMailServerType()+"): ");
               serverType = UtilityIL.readValue();
               System.out.print("description ("+msold.getDescription()+"): ");
               description = UtilityIL.readValue();
               System.out.print("protocol (imap/pop3) ("+msold.getProtocol()+"): ");
               protocol = UtilityIL.readValue();
               System.out.print("soft delete (y/n) ("+msold.getIsSoftDelete()+"): ");
               isSoftDelete = UtilityIL.readValue();
               System.out.print("Server Out ("+msold.getOutServer()+"): ");
               outServer = UtilityIL.readValue();
               System.out.print("Server Out Port ("+msold.getOutPort()+"): ");
               outPort = UtilityIL.readValue();
               System.out.print("server Out Authetication (y/n) ("+msold.getOutAuth()+"): ");
               outAuth = UtilityIL.readValue();
               System.out.print("Server In ("+msold.getInServer()+"): ");
               inServer = UtilityIL.readValue();
               System.out.print("Server In Port ("+msold.getInPort()+"): ");
               inPort = UtilityIL.readValue();
               System.out.print("SSL In (y/n) ("+msold.getIsSSLIn()+"): ");
               isSSLIn = UtilityIL.readValue();
               System.out.print("SSL  Out (y/n) ("+msold.getIsSSLOut()+"): ");
               isSSLOut = UtilityIL.readValue();
               System.out.print("key path ("+msold.getKeystorePath()+"): ");
               keystorePath = UtilityIL.readValue();
               System.out.print("key pwd ("+msold.getKeystorePwd()+"): ");
               keystorePwd = UtilityIL.readValue();
               System.out.print("Outbox Path ("+msold.getOutboxPath()+"): ");
               outboxPath = UtilityIL.readValue();
               System.out.print("Outbox Active (y/n) ("+msold.getOutboxActivation()+"): ");
               outboxActive = UtilityIL.readValue();
               System.out.print("Sent Path ("+msold.getSentPath()+"): ");
               sentPath = UtilityIL.readValue();
               System.out.print("Sent Active (y/n) ("+msold.getSentActivation()+"): ");
               sentActive = UtilityIL.readValue();
               System.out.print("Drafts Path ("+msold.getDraftsPath()+"): ");
               draftsPath = UtilityIL.readValue();
               System.out.print("Drafts Active (y/n) ("+msold.getDraftsActivation()+"): ");
               draftsActive = UtilityIL.readValue();
               System.out.print("Trash Path ("+msold.getTrashPath()+"): ");
               trashPath = UtilityIL.readValue();
               System.out.print("Trash Active (y/n) ("+msold.getTrashActivation()+"): ");
               trashActive = UtilityIL.readValue();
               
               
               MailServerAccount msa = new MailServerAccount();
               MailServer ms = new MailServer();
               
               ms.setMailServerId(msold.getMailServerId());                
               ms.setMailServerType(serverType); 
               ms.setDescription(description);   
               ms.setIsSoftDelete(Utility.booleanFromString(isSoftDelete)); 
               ms.setIsPublic(Utility.booleanFromString(isPublic)); 
               ms.setProtocol(protocol);      
               ms.setOutServer(outServer); 
               ms.setOutPort(Integer.parseInt(outPort)); 
               ms.setOutAuth(Utility.booleanFromString(outAuth)); 
               ms.setInServer(inServer); 
               ms.setInPort(Integer.parseInt(inPort)); 
               ms.setIsSSLIn(Utility.booleanFromString(isSSLIn)); 
               ms.setIsSSLOut(Utility.booleanFromString(isSSLOut)); 
               ms.setKeystorePath(keystorePath); 
               ms.setKeystorePwd(keystorePwd); 
               ms.setInboxPath("Inbox");  
               ms.setInboxActivation(Utility.booleanFromString("y")); 
               ms.setOutboxPath(outboxPath); 
               ms.setOutboxActivation(Utility.booleanFromString(outboxActive)); 
               ms.setSentPath(sentPath);   
               ms.setSentActivation(Utility.booleanFromString(sentActive)); 
               ms.setDraftsPath(draftsPath);   
               ms.setDraftsActivation(Utility.booleanFromString(draftsActive)); 
               ms.setTrashPath(trashPath);   
               ms.setTrashActivation(Utility.booleanFromString(trashActive)); 
               
               msa.setMailServer(ms);               
               
               //
               menuWSDAO.updateAccount(msa);
               
           }
           
       }
              
     } catch (Exception ex) {
       throw new InboxListenerException("Error updating accounts (" +
                                         ex.getMessage() + ")");
     }
  }  
  
  /**
   *
   */
  private void disableAccount() throws InboxListenerException {
     try {
                
       // get User Info
       System.out.print("user to be disabled (id): ");
       String accountID = UtilityIL.readValue();
       
       MailServerAccount msaold  = menuWSDAO.getAccountFromID(accountID);
       
       if (msaold != null){
           
           System.out.println("Disable the account ");
           System.out.println("  account ID : "+msaold.getAccountId());
           System.out.println("  username   : "+msaold.getUsername());
           System.out.print("ok ? (y/n): ");
           String check = UtilityIL.readValue();

           if (check.equals("y")){
              menuWSDAO.disableAccount(msaold.getAccountId());
           }

       }
       
     } catch (Exception ex) {
       throw new InboxListenerException("Error updating accounts (" +
                                         ex.getMessage() + ")");
     }
  }  
  
  /**
   *
   */
  private void enableAccount() throws InboxListenerException {
     try {
                
       // get User Info
       System.out.print("user to be enabled (id): ");
       String accountID = UtilityIL.readValue();
       
       MailServerAccount msaold  = menuWSDAO.getAccountFromID(accountID);
       
       if (msaold != null){
           
           System.out.println("Enable the account ");
           System.out.println("  account ID : "+msaold.getAccountId());
           System.out.println("  username   : "+msaold.getUsername());
           System.out.print("ok ? (y/n): ");
           String check = UtilityIL.readValue();

           if (check.equals("y")){
              menuWSDAO.enableAccount(msaold.getAccountId());
           }

       }
       
     } catch (Exception ex) {
       throw new InboxListenerException("Error updating accounts (" +
                                         ex.getMessage() + ")");
     }
  }  
  
  /**
   *
   */
  private void updateServer() throws InboxListenerException {
     try {
                
       // get User Info
       System.out.print("mail server to be updated (id): ");
       String serverID  = UtilityIL.readValue();
       MailServer msold = menuWSDAO.getMailServerFromID(serverID);
       
       if (msold != null){
           
           System.out.println("Mail Server ID ("+msold.getMailServerId()+"): ");
           System.out.println("public (y) ("+msold.getIsPublic()+"): ");
               
           System.out.print("server type (Exchange/Courier/Other) ("+msold.getMailServerType()+"): ");
           String serverType = UtilityIL.readValue();
           System.out.print("description ("+msold.getDescription()+"): ");
           String description = UtilityIL.readValue();
           System.out.print("protocol (imap/pop3) ("+msold.getProtocol()+"): ");
           String protocol = UtilityIL.readValue();
           System.out.print("soft delete (y/n) ("+msold.getIsSoftDelete()+"): ");
           String isSoftDelete = UtilityIL.readValue();
           System.out.print("Server Out ("+msold.getOutServer()+"): ");
           String outServer = UtilityIL.readValue();
           System.out.print("Server Out Port ("+msold.getOutPort()+"): ");
           String outPort = UtilityIL.readValue();
           System.out.print("server Out Authetication (y/n) ("+msold.getOutAuth()+"): ");
           String outAuth = UtilityIL.readValue();
           System.out.print("Server In ("+msold.getInServer()+"): ");
           String inServer = UtilityIL.readValue();
           System.out.print("Server In Port ("+msold.getInPort()+"): ");
           String inPort = UtilityIL.readValue();
           System.out.print("SSL In (y/n) ("+msold.getIsSSLIn()+"): ");
           String isSSLIn = UtilityIL.readValue();
           System.out.print("SSL Out (y/n) ("+msold.getIsSSLOut()+"): ");
           String isSSLOut = UtilityIL.readValue();
           System.out.print("key path ("+msold.getKeystorePath()+"): ");
           String keystorePath = UtilityIL.readValue();
           System.out.print("key pwd ("+msold.getKeystorePwd()+"): ");
           String keystorePwd = UtilityIL.readValue();
           System.out.print("Outbox Path ("+msold.getOutboxPath()+"): ");
           String outboxPath = UtilityIL.readValue();
           System.out.print("Outbox Active (y/n) ("+msold.getOutboxActivation()+"): ");
           String outboxActive = UtilityIL.readValue();
           System.out.print("Sent Path ("+msold.getSentPath()+"): ");
           String sentPath = UtilityIL.readValue();
           System.out.print("Sent Active (y/n) ("+msold.getSentActivation()+"): ");
           String sentActive = UtilityIL.readValue();
           System.out.print("Drafts Path ("+msold.getDraftsPath()+"): ");
           String draftsPath = UtilityIL.readValue();
           System.out.print("Drafts Active (y/n) ("+msold.getDraftsActivation()+"): ");
           String draftsActive = UtilityIL.readValue();
           System.out.print("Trash Path ("+msold.getTrashPath()+"): ");
           String trashPath = UtilityIL.readValue();
           System.out.print("Trash Active (y/n) ("+msold.getTrashActivation()+"): ");
           String trashActive = UtilityIL.readValue();
           
           MailServer  ms  = new MailServer();

           ms.setMailServerId(msold.getMailServerId());                
           ms.setIsPublic(msold.getIsPublic()); 
           
           ms.setMailServerType(serverType); 
           ms.setDescription(description);   
           ms.setIsSoftDelete(Utility.booleanFromString(isSoftDelete)); 
           ms.setProtocol(protocol);      
           ms.setOutServer(outServer); 
           ms.setOutPort(Integer.parseInt(outPort)); 
           ms.setOutAuth(Utility.booleanFromString(outAuth)); 
           ms.setInServer(inServer); 
           ms.setInPort(Integer.parseInt(inPort)); 
           ms.setIsSSLIn(Utility.booleanFromString(isSSLIn)); 
           ms.setIsSSLOut(Utility.booleanFromString(isSSLOut)); 
           ms.setKeystorePath(keystorePath); 
           ms.setKeystorePwd(keystorePwd); 
           ms.setInboxPath("Inbox");  
           ms.setInboxActivation(Utility.booleanFromString("y")); 
           ms.setOutboxPath(outboxPath); 
           ms.setOutboxActivation(Utility.booleanFromString(outboxActive)); 
           ms.setSentPath(sentPath);   
           ms.setSentActivation(Utility.booleanFromString(sentActive)); 
           ms.setDraftsPath(draftsPath);   
           ms.setDraftsActivation(Utility.booleanFromString(draftsActive)); 
           ms.setTrashPath(trashPath);   
           ms.setTrashActivation(Utility.booleanFromString(trashActive)); 


           menuWSDAO.updateMailServer(ms);
           
       }
       
     } catch (Exception ex) {
       throw new InboxListenerException("Error updating accounts (" +
                                         ex.getMessage() + ")");
     }
     
  }  
 
  /**
   *
   */
  private void deleteAccount() throws InboxListenerException {
     try {
       System.out.print("Account ID : ");
       String accoutnID = UtilityIL.readValue();

       menuWSDAO.deleteAccount(accoutnID);

     } catch (Exception ex) {
       throw new InboxListenerException("Error deleting account (" +
                                         ex.getMessage() + ")");
     }
  }

  /**
   *
   */
  private void deleteServer() throws InboxListenerException {
     try {
       System.out.print("Mail Server ID : ");
       String serverID = UtilityIL.readValue();

       menuWSDAO.deleteMailServer(serverID);

     } catch (Exception ex) {
       throw new InboxListenerException("Error deleting mail server (" +
                                         ex.getMessage() + ")");
     }
  }
  
  /**
   *
   */
  private void checkAccount() throws InboxListenerException {
      
     try {
         
         
         
       System.out.print("MS Login: ");
       String msLogin = UtilityIL.readValue();
       System.out.print("MS password: ");
       String msPassword = UtilityIL.readValue();
       
       System.out.print("protocol (imap/pop3): ");
       String protocol = UtilityIL.readValue();
       
       System.out.print("Server In: ");
       String inServer = UtilityIL.readValue();
       System.out.print("Server In Port: ");
       String inPort = UtilityIL.readValue();

       System.out.print("SSL Input (y/n): ");
       String isSSLIn = UtilityIL.readValue();
       System.out.print("key path: ");
       String keystorePath = UtilityIL.readValue();
       System.out.print("key pwd: ");
       String keystorePwd = UtilityIL.readValue();
         
       
        MailServerAccount msa = new MailServerAccount();
        MailServer        ms  = new MailServer();

        // account
        msa.setAccountId(null);   
        msa.setUsername(null);   
        msa.setMsLogin(msLogin);    
        msa.setMsPassword(msPassword); 

        // mail server
        ms.setMailServerId(null);                
        ms.setProtocol(protocol);      
        ms.setInServer(inServer); 
        ms.setInPort(Integer.parseInt(inPort)); 
        ms.setIsSSLIn(Utility.booleanFromString(isSSLIn)); 
        ms.setKeystorePath(keystorePath); 
        ms.setKeystorePwd(keystorePwd); 

        msa.setMailServer(ms);               
              
        int isOK = menuWSDAO.checkAccount(msa);
        
        System.out.println("Account verification result code --> " + isOK);
        
     } catch (Exception ex) {
        throw new InboxListenerException("Error checking account (" +
                                          ex.getMessage() + ")");
     }
  }  
  
  /**
   *
   */
  private void imapFolder() throws InboxListenerException {
     try {
         
       System.out.print("username: ");
       String username = UtilityIL.readValue();
         
        MailServerAccount msa = menuWSDAO.getAccount(username);
        
        if (msa != null) {
            FolderManager fm = new FolderManager();
            fm.imapFolderList(msa);
        } else {
            System.out.println("Account not found");
        }
        
     } catch (Exception ex) {
        throw new InboxListenerException("Error getting account (" +
                                          ex.getMessage() + ")");
     }
  }  
  
  /**
   *
   */
  private MailServer getServerFromArray(MailServer[] msl, String idms) 
    throws InboxListenerException {
     MailServer ms = null;     
     String idtmp  = null;
     try {
         for (int i=0; i<msl.length; i++){
             idtmp = msl[i].getMailServerId();
             if (idtmp.equals(idms)){
                 return msl[i];
             }
         }
     } catch (Exception ex) {
        throw new InboxListenerException("Error selcting account (" +
                                          ex.getMessage() + ")");
     }
     return null;
  }  
  
  
}
