/**
 * Copyright (C) 2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.inboxlistener.msdao;


import com.funambol.email.model.MailServerAccount;
import com.funambol.email.util.Def;


/**
 *
 *
 * @version $Id: MailboxMSDAOFactory.java,v 1.3 2007/02/07 09:45:33 gbmiglia Exp $
 */
public class MailboxMSDAOFactory {


   public static IMailboxMSDAO getMailboxMSDAO(MailServerAccount _msa, 
                                               boolean _saveSubject,
                                               boolean _saveSender) {

        IMailboxMSDAO mbmsdao = null;
        
        String serverType = _msa.getMailServer().getMailServerType();

        if      (serverType.equalsIgnoreCase(Def.SERVER_TYPE_GMAIL)){
          mbmsdao = new MailboxMSDAOGmail(_msa, _saveSubject, _saveSender);
        } else {
          mbmsdao =  new MailboxMSDAO(_msa, _saveSubject, _saveSender);
        }

        return mbmsdao;
    }

}
