/**
 * Copyright (C) 2005-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.model;

import com.funambol.email.util.Def;

/**
 *
 * @version $Id: DefaultFolder.java,v 1.3 2007/01/26 17:38:43 gbmiglia Exp $
 */
public class DefaultFolder {


    private String  inboxName;
    private String  inboxId;
    private boolean isInboxInMailServer = true;
    private String  inboxRole = Def.FOLDER_INBOX_ROLE;

    private String  outboxName;
    private String  outboxId;
    private boolean isOutboxInMailServer = true;
    private String  outboxRole = Def.FOLDER_OUTBOX_ROLE;

    private String  sentName;
    private String  sentId;
    private boolean isSentInMailServer = true;
    private String  sentRole = Def.FOLDER_SENT_ROLE;

    private String  draftsName;
    private String  draftsId;
    private boolean isDraftsInMailServer = true;
    private String  draftsRole = Def.FOLDER_DRAFTS_ROLE;

    private String  trashName;
    private String  trashId;
    private boolean isTrashInMailServer = true;
    private String  trashRole = Def.FOLDER_TRASH_ROLE;


    public DefaultFolder(){
    }


    public DefaultFolder(String i, String o, String s, String d, String t){
        this.inboxName  = i;
        this.inboxId    = Def.FOLDER_INBOX_ID;
        this.outboxName = o;
        this.outboxId   = Def.FOLDER_OUTBOX_ID;
        this.sentName   = s;
        this.sentId     = Def.FOLDER_SENT_ID;
        this.draftsName = d;
        this.draftsId   = Def.FOLDER_DRAFTS_ID;
        this.trashName  = t;
        this.trashId    = Def.FOLDER_TRASH_ID;
    }

    public String getInboxName() {
        return inboxName;
    }

    public String getInboxId() {
        return inboxId;
    }

    public boolean isInboxInMailServer() {
        return isInboxInMailServer;
    }
    
    public String getInboxRole() {
        return inboxRole;
    }
    

    public String getOutboxName() {
        return outboxName;
    }

    public String getOutboxId() {
        return outboxId;
    }

    public boolean isOutboxInMailServer() {
        return isOutboxInMailServer;
    }

    public String getOutboxRole() {
        return outboxRole;
    }
    
    
    public String getSentName() {
        return sentName;
    }

    public String getSentId() {
        return sentId;
    }

    public boolean isSentInMailServer() {
        return isSentInMailServer;
    }

    public String getSentRole() {
        return sentRole;
    }
    
    public String getDraftsName() {
        return draftsName;
    }

    public String getDraftsId() {
        return draftsId;
    }

    public boolean isDraftsInMailServer() {
        return isDraftsInMailServer;
    }

    public String getDraftsRole() {
        return draftsRole;
    }
    
    public String getTrashName() {
        return trashName;
    }

    public String getTrashId() {
        return trashId;
    }

    public boolean isTrashInMailServer() {
        return isTrashInMailServer;
    }

    public String getTrashRole() {
        return trashRole;
    }

    public void setInboxName(String inboxName) {
        this.inboxName = inboxName;
    }

    public void setInboxId(String inboxId) {
        this.inboxId = inboxId;
    }

    public void setIsInboxInMailServer(boolean _isInboxInMailServer) {
        this.isInboxInMailServer = _isInboxInMailServer;
    }

    public void setInboxRole(String inboxRole) {
        this.inboxRole = inboxRole;
    }
    
    public void setOutboxId(String outboxId) {
        this.outboxId = outboxId;
    }

    public void setOutboxName(String outboxName) {
        this.outboxName = outboxName;
    }

    public void setIsOutboxInMailServer(boolean _isOutboxInMailServer) {
        this.isOutboxInMailServer = _isOutboxInMailServer;
    }

    public void setOutboxRole(String outboxRole) {
        this.outboxRole = outboxRole;
    }
    
    public void setSentName(String sentName) {
        this.sentName = sentName;
    }

    public void setSentId(String sentId) {
        this.sentId = sentId;
    }

    public void setIsSentInMailServer(boolean _isSentInMailServer) {
        this.isSentInMailServer = _isSentInMailServer;
    }

    public void setSentRole(String sentRole) {
        this.sentRole = sentRole;
    }
    
    public void setDraftsName(String draftName) {
        this.draftsName = draftName;
    }

    public void setDraftsId(String draftId) {
        this.draftsId = draftId;
    }

    public void setIsDraftsInMailServer(boolean _isDraftInMailServer) {
        this.isDraftsInMailServer = _isDraftInMailServer;
    }

    public void setDraftsRole(String draftRole) {
        this.draftsRole = draftRole;
    }
    
    public void setTrashName(String trashName) {
        this.trashName = trashName;
    }

    public void setTrashId(String trashId) {
        this.trashId = trashId;
    }

    public void setIsTrashInMailServer(boolean _isTrashInMailServer) {
        this.isTrashInMailServer = _isTrashInMailServer;
    }

    public void setTrashRole(String trashRole) {
        this.trashRole = trashRole;
    }
       
}
