/**
 * Copyright (C) 2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.model;


/**
 *
 * @version $Id: MailServer.java,v 1.4 2007/02/05 13:31:51 gbmiglia Exp $
 */
public class MailServer implements java.io.Serializable {

    private String mailServerId;
    private String description;
    private boolean isPublic;
    private String mailServerType;
    private String protocol;
    
    private String inServer;
    private int inPort;
    private String outServer;
    private int outPort;
    private boolean outAuth;
    private boolean isSSLIn;
    private boolean isSSLOut;
    private String keystorePath;
    private String keystorePwd;
    
    private String inboxPath;
    private boolean inboxActivation;
    private String outboxPath;
    private boolean outboxActivation;
    private String sentPath;
    private boolean sentActivation;
    private String draftsPath;
    private boolean draftsActivation ;
    private String trashPath;
    private boolean trashActivation;
    
    private boolean isSoftDelete;


    public MailServer(){
    }


    public String getMailServerId() {
        return mailServerId;
    }
    public String getDescription() {
        return description;
    }
    public boolean getIsPublic() {
        return isPublic;
    }
    public String getMailServerType() {
        return mailServerType;
    }
    public String getProtocol() {
        return protocol;
    }
    public String getInServer() {
        return inServer;
    }
    public int getInPort() {
        return inPort;
    }
    public String getOutServer() {
        return outServer;
    }
    public int getOutPort() {
        return outPort;
    }
    public boolean getOutAuth() {
        return outAuth;
    }
    public boolean getIsSSLIn() {
        return isSSLIn;
    }
    public boolean getIsSSLOut() {
        return isSSLOut;
    }
    public String getKeystorePath() {
        return keystorePath;
    }
    public String getKeystorePwd() {
        return keystorePwd;
    }
    public String getInboxPath() {
        return inboxPath;
    }
    public boolean getInboxActivation() {
        return inboxActivation;
    }
    public String getOutboxPath() {
        return outboxPath;
    }
    public boolean getOutboxActivation() {
        return outboxActivation;
    }
    public String getSentPath() {
        return sentPath;
    }
    public boolean getSentActivation() {
        return sentActivation;
    }
    public String getDraftsPath() {
        return draftsPath;
    }
    public boolean getDraftsActivation() {
        return draftsActivation;
    }    
    public String getTrashPath() {
        return trashPath;
    }
    public boolean getTrashActivation() {
        return trashActivation;
    }
    public boolean getIsSoftDelete() {
        return isSoftDelete;
    }
    
        
    public void setMailServerId(String _mailServerId) {
        mailServerId = _mailServerId;
    }
    public void setDescription(String _description) {
        description = _description;
    }
    public void setIsPublic(boolean _isPublic) {
        isPublic = _isPublic;
    }
    public void setMailServerType(String _mailServerType) {
        mailServerType = _mailServerType;
    }
    public void setProtocol(String _protocol) {
        protocol = _protocol;
    }
    public void setInServer(String _inServer) {
        inServer = _inServer;
    }
    public void setInPort(int _inPort) {
        inPort = _inPort;
    }
    public void setOutServer(String _outServer) {
        outServer = _outServer;
    }
    public void setOutPort(int _outPort) {
        outPort = _outPort;
    }
    public void setOutAuth(boolean _outAuth) {
        outAuth = _outAuth;
    }
    public void setIsSSLIn(boolean _isSSLIn) {
        isSSLIn = _isSSLIn;
    }
    public void setIsSSLOut(boolean _isSSLOut) {
        isSSLOut = _isSSLOut;
    }
    public void setKeystorePath(String _keystorePath) {
        keystorePath = _keystorePath;
    }
    public void setKeystorePwd(String _keystorePwd) {
        keystorePwd = _keystorePwd;
    }
    public void setInboxPath(String _inboxPath) {
        inboxPath = _inboxPath;
    }
    public void setInboxActivation(boolean _inboxActivation) {
        inboxActivation = _inboxActivation;
    }
    public void setOutboxPath(String _outboxPath) {
        outboxPath = _outboxPath;
    }
    public void setOutboxActivation(boolean _outboxActivation) {
        outboxActivation = _outboxActivation;
    }
    public void setSentPath(String _sentPath) {
        sentPath = _sentPath;
    }
    public void setSentActivation(boolean _sentActivation) {
        sentActivation = _sentActivation;
    }
    public void setDraftsPath(String _draftsPath) {
        draftsPath = _draftsPath;
    }
    public void setDraftsActivation(boolean _draftsActivation) {
        draftsActivation = _draftsActivation;
    }    
    public void setTrashPath(String _trashPath) {
        trashPath = _trashPath;
    }
    public void setTrashActivation(boolean _trashActivation) {
        trashActivation = _trashActivation;
    }    
    public void setIsSoftDelete(boolean _isSoftDelete) {
        isSoftDelete = _isSoftDelete;
    }
    
    public String toString() {
        return "MailServer:\n " +
               "\nid             : " + this.mailServerId +
               "\nServer Type    : " + this.mailServerType  +
               "\nServer         : " + this.description +
               "\npublic         : " + this.isPublic +
               "\nprotocol       : " + this.protocol +
               "\nsoftDelete     : " + this.isSoftDelete +
               "\nOut            : " + this.outServer +
               "\nOut Port       : " + this.outPort +
               "\nOut Auth       : " + this.outAuth +
               "\nIn             : " + this.inServer +
               "\nIn Port        : " + this.inPort +
               "\nSSL            : " + this.isSSLIn +
               "\nSSL            : " + this.isSSLOut +
               "\nkey path       : " + this.keystorePath +
               "\nkey pwd        : " + "***********" +
               "\nInbox          : " + this.inboxPath + " - " + this.inboxActivation +
               "\nOutbox         : " + this.outboxPath + " - " + this.outboxActivation +
               "\nSent           : " + this.sentPath + " - " + this.sentActivation +
               "\nDrafts         : " + this.draftsPath + " - " + this.draftsActivation +
               "\nTrash          : " + this.trashPath + " - " + this.trashActivation + "\n";
    }    
    
    public String toStringForCommandLine() {
        return " (Server id: " + this.mailServerId +
               " - Server: " + this.description +
               " - protocol: " + this.protocol + ")]";
    }        
}
