/**
 * Copyright (C) 2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.model;


/**
 *
 * @version $Id: MailServerAccount.java,v 1.6 2007/01/26 08:23:38 gbmiglia Exp $
 */
public class MailServerAccount implements java.io.Serializable {


    private String     accountId ;
    private String     username ;
    private String     msLogin ;
    private String     msPassword ;    
    private String     msAddress ;    
    private String     listenerId ;
    private boolean    activation;
    private boolean    push;
    private int        refreshTime ;   
    private int        maxEmailNumber ;
    private int        maxImapEmail ;
    
    private MailServer mailServer;
    
    
    public MailServerAccount(){
    }


    public String getAccountId() {
        return accountId;
    }
    public String getUsername() {
        return username;
    }
    public String getMsLogin() {
        return msLogin;
    }
    public String getMsPassword() {
        return msPassword;
    }
    public String getMsAddress() {
        return msAddress;
    }
    public String getListenerId() {
        return listenerId;
    }
    public boolean getActivation() {
        return activation;
    }
    public boolean getPush() {
        return push;
    }
    public int getRefreshTime() {
        return refreshTime;
    }
    public int getMaxEmailNumber() {
        return maxEmailNumber;
    }
    public int getMaxImapEmail() {
        return maxImapEmail;
    }
    public MailServer getMailServer() {
        return mailServer;
    }
    
    /////////////

    public void setAccountId(String _accountId) {
        accountId = _accountId;
    }
    public void setUsername(String _username) {
        username = _username;
    }
    public void setMsLogin(String _msLogin) {
        msLogin = _msLogin;
    }
    public void setMsPassword(String _msPassword) {
        msPassword = _msPassword;
    }
    public void setMsAddress(String _msAddress) {
        msAddress = _msAddress;
    }
    public void setListenerId(String _listenerId) {
        listenerId = _listenerId;
    }
    public void setActivation(boolean _activation) {
        activation = _activation;
    }
    public void setPush(boolean _push) {
        push = _push;
    }
    public void setRefreshTime(int _refreshTime) {
        refreshTime = _refreshTime;
    }
    public void setMaxEmailNumber(int _maxEmailNumber) {
        maxEmailNumber = _maxEmailNumber;
    }
    public void setMaxImapEmail(int _maxImapEmail) {
        maxImapEmail = _maxImapEmail;
    }
    public void setMailServer(MailServer _mailServer) {
        mailServer = _mailServer;
    }
    
    public String toString() {
        String out = "Account:\n " +
               "\nid             : " + this.accountId +
               "\nuserName       : " + this.username  +
               "\nMSLogin        : " + this.msLogin   +
               "\nMSPassword     : " + "***********"  +
               "\nMSAddress      : " + this.msAddress  +
               "\nActive         : " + this.activation +
               "\nRefresh time   : " + this.refreshTime +
               "\nPush           : " + this.push +
               "\nMax Email      : " + this.maxEmailNumber +
               "\nMax IMAP Email : " + this.maxImapEmail ;
        if (this.mailServer != null){
            out = out + "\nMailServer     : " + this.mailServer.toString();
        }
        
        return out ;
    } 
       
    public String toStringForCommandLine() {
        String out = "id: " + this.accountId + " - userName: " + this.username  +
               " [MSLogin: " + this.msLogin   +
               " - MSAddress: " + this.msAddress   +
               " - Active: " + this.activation +
               " - Push: " + this.push +
               " - Refresh time: " + this.refreshTime +
               " - Max Email: " + this.maxEmailNumber ;
        if (this.mailServer != null){
            out = out + this.mailServer.toStringForCommandLine();
        }
        
        return out ;
    } 
    
}
