/**
 * Copyright (C) 2005-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.model;


import com.funambol.framework.engine.SyncItemKey;

/**
 *
 * @version $Id: SyncItemInfo.java,v 1.9 2007/01/23 10:16:55 gbmiglia Exp $
 */
public class SyncItemInfo {

    // -------------------------------------------------------------- Properties

    /**    */
    private SyncItemKey key;
        
    /**    */
    private long lastCrc;

    /**    */
    private String messageID;

    /**    */
    private java.util.Date headerDate;
        
    /**    */
    private java.util.Date headerReceived;
    
    /**     */
    private String subject;
    
    /**     */
    private String sender;
    
    /**    
     * define if the email has a problem in the parsing steps
     * in the next sync session this mail will be skipped
     */
    private String invalid;

    /**  
     * define if the email is handled by the sync process.
     * Used by the InboxListener in order to notify to the Server
     * if there is a new email in the inbox  
     */
    private String internal;
    
    /**
     * define if the item is an email or a folder.
     */
    private String isEmail;
    
    /**
     * status of the item : N, D, U
     */
    private String status;

    
    // ------------------------------------------------------------ Constructors

    /**
     *
     */
    public SyncItemInfo() {
    }
          
    /**
     * 
     * 
     * @param _messageID 
     * @param _headerDate 
     * @param _received 
     * @param _subject 
     * @param _sender 
     * @param _internal 
     * @param _isEmail 
     * @param _status 
     * @param _sKey String
     * @param _lastCrc long
     * @param _invalid String
     */
    public SyncItemInfo(String _sKey, 
                        long _lastCrc, 
                        String _messageID,
                        java.util.Date _headerDate,
                        java.util.Date _received,
                        String _subject,
                        String _sender,
                        String _invalid,
                        String _internal,
                        String _isEmail,
                        String _status) {
        this.key        = new SyncItemKey(_sKey);
        this.lastCrc    = _lastCrc;
        this.messageID  = _messageID;
        this.headerDate = _headerDate;
        this.headerReceived = _received;
        this.subject    = _subject;
        this.sender     = _sender;
        this.invalid    = _invalid;
        this.internal   = _internal;
        this.isEmail    = _isEmail;
        this.status     = _status;
    }    
    
    // ---------------------------------------------------------- Public Methods

    /**
     *
     * @return SyncItemKey
     */
    public SyncItemKey getKey() {
        return key;
    }

    /**
     * 
     * 
     * @param _key 
     */
    public void setKey(SyncItemKey _key) {
        this.key = _key;
    }

    /**
     * 
     * 
     * @param _key 
     */
    public void setKey(String _key) {
        this.key = new SyncItemKey(_key);
    }
    
    /**
     *
     * @return lastCrc long
     */
    public long getLastCrc() {
        return lastCrc;
    }

    /**
     * 
     * 
     * @param _lastCrc 
     */
    public void setLastCrc(long _lastCrc) {
        this.lastCrc = _lastCrc;
    }
        
    /**
     *
     * @return headerDate java.util.Date
     */
    public java.util.Date getHeaderDate() {
        return headerDate;
    }

    /**
     * 
     * 
     * @param _headerDate 
     */
    public void setHeaderDate(java.util.Date _headerDate) {
        this.headerDate = _headerDate;
    }
    
    /**
     *
     * @return headerDate java.util.Date
     */
    public java.util.Date getHeaderReceived() {
        return headerReceived;
    }

    /**
     * 
     * 
     * @param _headerReceived 
     */
    public void setHeaderReceived(java.util.Date _headerReceived) {
        this.headerReceived = _headerReceived;
    }
    
    /**
     *
     * @return messageID String
     */
    public String getMessageID() {
        return this.messageID;
    }

    /**
     *
     * @param _messageID String
     */
    public void setMessageID(String _messageID) {
        this.messageID = _messageID;
    }    
    
    /**
     *
     * @return subject String
     */
    public String getSubject() {
        return this.subject;
    }

    /**
     *
     * @param _subject String
     */
    public void setSubject(String _subject) {
        this.subject = _subject;
    }    
    
    /**
     *
     * @return sender String
     */
    public String getSender() {
        return this.sender;
    }

    /**
     *
     * @param _sender String
     */
    public void setSender(String _sender) {
        this.sender = _sender;
    }    
    
    /**
     *
     * @return invalid String
     */
    public String getInvalid() {
        return this.invalid;
    }

    /**
     *
     * @param _invalid String
     */
    public void setInvalid(String _invalid) {
        this.invalid = _invalid;
    }    

    /**
     *
     * @return internal String
     */
    public String getInternal() {
        return this.internal;
    }

    /**
     *
     * @param _internal String
     */
    public void setInternal(String _internal) {
        this.internal = _internal;
    }    
    
    /**
     *
     * @return isEmail String
     */
    public String getIsEmail() {
        return this.isEmail;
    }

    /**
     *
     * @param _isEmail String
     */
    public void setIsEmail(String _isEmail) {
        this.isEmail = _isEmail;
    }    
    
    
    /**
     *
     * @return status String
     */
    public String getStatus() {
        return this.status;
    }

    /**
     *
     * @param _status String
     */
    public void setStatus(String _status) {
        this.status = _status;
    }    
    
    /**
     *
     */
    public String toString() {
        String out = 
               "GUID [" + this.key.getKeyAsString() + "]" +
               " CRC [" + this.lastCrc  + "]" +
               " Message-ID [" + this.messageID  + "]" +
               " Date [" + this.headerDate  + "]" +
               " Received [" + this.headerReceived  + "]" +
               " Sender [" + this.sender + "]" +
               " Subject [" + this.subject + "]" +
               " Status [" + this.status + "]" +
               " Invalid [" + this.invalid + "]" +
               " IsMail [" + this.isEmail + "]\n" ;        
        return out ;
    } 
    
    
}
