/**
 * Copyright (C) 2005-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.pdi.folder;


import com.funambol.common.pim.common.Property;

/**
 * An object representing a folder.
 * This class can be used to store and retrive all
 * information about folder.
 *
 * @version $Id: Folder.java,v 1.4 2007/01/15 16:37:39 nichele Exp $
 */
public class Folder {

    private Property  uid;       // String  --> will be used String type
    private Property  parentId;  // String  --> will be used String type
    private Property  name;      // String  --> will be used String type
    private Property  created;   // date    --> will be used String type
    private Property  modified;  // date    --> will be used String type
    private Property  accessed;  // date    --> will be used String type
    private Property  role;      // String  --> will be used String type
    // @todo Ext


    /**
     * Creates an empty Folder
     */
    public Folder() {
        uid       = new Property();
        parentId  = new Property();
        name      = new Property();
        created   = new Property();
        modified  = new Property();
        accessed  = new Property();
        role      = new Property();
    }

    /**
     * Returns the uid of this folder
     *
     * @return the uid of this folder
     */
    public Property getUID() {
        return uid;
    }

    /**
     * set the uid of this folder
     *
     */
    public void setUID(Property uid) {
        this.uid = uid;
    }

    /**
     * Returns the parentId of this folder
     *
     * @return the parentId of this folder
     */
    public Property getParentId() {
        return parentId;
    }

    /**
     * set the parentId of this folder
     *
     */
    public void setParentId(Property parentId) {
        this.parentId = parentId;
    }


    /**
     * Returns the name of this folder
     *
     * @return the name of this folder
     */
    public Property getName() {
        return name;
    }


    /**
     * Returns the created of this folder
     *
     * @return the created of this folder
     */
    public Property getCreated() {
        return created;
    }

    /**
     * Returns the modified of this folder
     *
     * @return the modified of this folder
     */
    public Property getModified() {
        return modified;
    }

    /**
     * Returns the accessed of this folder
     *
     * @return the accessed of this folder
     */
    public Property getAccessed() {
        return accessed;
    }


    /**
     * Returns the role of this folder
     *
     * @return the role of this folder
     */
    public Property getRole() {
        return role;
    }

    /**
     *
     * @return String
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("Email:");
        sb.append("\nUID       : " + this.getUID().getPropertyValue());
        sb.append("\nName      : " + this.getName().getPropertyValue());
        sb.append("\nCreated   : " + this.getCreated().getPropertyValue());
        sb.append("\nModified  : " + this.getModified().getPropertyValue());
        sb.append("\nAccessed  : " + this.getAccessed().getPropertyValue());
        sb.append("\nRole      : " + this.getRole().getPropertyValue());
        return sb.toString();
    }
}
