/**
 * Copyright (C) 2005-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.pdi.mail;



import com.funambol.common.pim.common.Property;


/**
 * An object representing a email.
 * This class can be used to store and retrive all
 * information about email.
 *
 * @version $Id: EmailItem.java,v 1.7 2007/01/15 16:37:39 nichele Exp $
 */
public class EmailItem
        extends Property {

    /**
     * Creates an empty email item
     */
    public EmailItem() {
        super();
    }

    /**
     * Returns the header of this mail
     *
     * @return the header of this mail
     */
    public String getStringRFC2822() {
        return String.valueOf(this.getPropertyValue());
    }


    /**
     * <p>Returns a string representation of the object</p>
     * @return a string representation of the object
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("");
        sb.append(this.getPropertyValue());
        return sb.toString();
    }


}
