/**
 * Copyright (C) 2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.pdi.mail;


import com.funambol.email.util.Def;
import java.util.ArrayList;
import java.util.List;

/**
 * An object representing a extension field.
 *
 * @version $Id: Ext.java,v 1.8 2007/01/30 17:22:39 gbmiglia Exp $
 */
public class Ext {

    /**
     * if the email is truncated
     */
    private boolean   truncated = false;  
    
    /**
     * entire email size
     * the header size is approximated to 200b
     */
    private String    xsize = "" + (200 + Def.CONTENT_BODY.length());  
    
    /**
     * (body size) if body is not truncated 
     * (body size - filter size) if body is truncated 
     */
    private String    xvalBody = "" + Def.CONTENT_BODY.length(); 
    
    /**
     *
     */
    private List      xvalAttach;  
    
    /**
     *
     */
    private String    xnam;  


    /**
     * Creates an empty mail
     */
    public Ext() {
        truncated  = false;
        xsize      = new String();
        xnam       = new String();
        xvalBody   = new String();
        xvalAttach = new ArrayList();
    }
    
    
    /**
     *
     */
    public boolean isTruncated() {
        return this.truncated;
    }

    /**
     *
     */
    public void setTruncated(boolean _truncated) {
        this.truncated = _truncated;
    }
    
    
    /**
     *
     */
    public String getXnam() {
        return this.xnam;
    }

    /**
     *
     */
    public void setXnam(String _xnam) {
        this.xnam = _xnam;
    }

    /**
     *
     */
    public String getXsize() {
        return this.xsize;
    }

    /**
     *
     */
    public void setXsize(String _xsize) {
        this.xsize = _xsize;
    }
    
    /**
     *
     */
    public String getXvalBody() {
        return this.xvalBody;
    }

    /**
     *
     */
    public void setXvalBody(String _xvalBody) {
        this.xvalBody = _xvalBody;
    }

    /**
     *
     */
    public List getXvalAttach() {
        return this.xvalAttach;
    }

    /**
     *
     */
    public void setXvalAttach(List _xvalAttach) {
        this.xvalAttach = _xvalAttach;
    }
    
    /**
     * @return String
     */
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("\nXNam: ").append(this.getXnam());
        sb.append("\nXVal: ").append(this.getXvalBody());
        for (int i=0; i<this.getXvalAttach().size(); i++){
           sb.append("\nXVal: ").append(this.getXvalAttach().get(i));            
        }
        return sb.toString();
    }    

}
