/**
 * Copyright (C) 2005-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.transport  ;

import javax.mail.Message;
import javax.mail.event.MessageCountListener;
import javax.mail.event.MessageCountEvent;
import com.sun.mail.imap.IMAPFolder;

import com.funambol.email.items.dao.ImapEntityDAO;
import com.funambol.email.util.Def;
import com.funambol.framework.logging.FunambolLogger;
import com.funambol.framework.logging.FunambolLoggerFactory;


/**
 *
 * <p>
 *    This class implemets a listener when a messages is added
 *    to a folder.
 * </p>
 *
 * @version $Id: ImapMessageCountListener.java,v 1.4 2007/02/01 09:10:38 gbmiglia Exp $
 */
public class ImapMessageCountListener implements MessageCountListener
{
  
    /**     */
    protected static FunambolLogger log = FunambolLoggerFactory.getLogger(Def.LOGGER_NAME);
    
    /**     */
    private long[] lastUIDs ;


  /**
   * Invoked when messages are added into a folder.
   *
   * @param e MessageCountEvent
   */
  public void messagesAdded(MessageCountEvent e) {

     try {
        Message[] msgs = e.getMessages();

        if (msgs != null){
          int num = msgs.length;
          lastUIDs = new long[num];
          for (int i = 0; i < num; i++){
             Message msg = msgs[i];
             IMAPFolder f = (IMAPFolder)msg.getFolder();
             long uid = f.getUID(msg);
             this.lastUIDs[i] = uid;
          }
        }

        ImapEntityDAO.uid_has_been_set.setTrue();

     } catch (Exception ce){
        log.error("Error in method messagesAdded" + ce.toString());           
     }

  }

  /**
   *
   *
   * @return long[]
   */
  public long[] getLastUIDs(){
     return this.lastUIDs;
  }


  /**
   * Invoked when messages are removed (expunged) from a folder.
   *
   * @param e MessageCountEvent
   */
  public void messagesRemoved(MessageCountEvent e) {
  }

}
