/**
 * Copyright (C) 2005-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.util;


/**
 * @version $Id: Def.java,v 1.42 2007/03/19 13:20:57 gbmiglia Exp $
 */
public class Def {


    public static final String LOGGER_NAME = "funambol.email";
    
    /**
     * this constant must be set using the information about the 
     * syncml client. 
     * At the moment we have 
     * - windows mobile plug-in for mobile outlook
     * - funambol j2me syncml email client
     * (these are only mobile devices)
     */
    public static final boolean IS_DEVICE = true;
       
    // separetor for the GUID creation
    public static final String SEPARATOR_FIRST  = "/";    
    public static final String SEPARATOR_SECOND = "-FUN-"; // must be weird

    // prefix for the thread in the inbox-listerner
    public static final String IL_PREFIX = "IL-"; 
    
    public static final String TYPE_EMAIL  = "application/vnd.omads-email+xml";
    public static final String TYPE_FOLDER = "application/vnd.omads-folder+xml";

    public static final String ID_COUNTER_SENT       = "email.sentid";
    public static final String ID_COUNTER_FOLDER     = "email.folderid";
    
    public static final String ID_COUNTER_MAILSERVER = "email.mailserverid";
    public static final String ID_COUNTER_USER       = "email.userid";
    public static final String ID_COUNTER_INBOX      = "email.cacheid";

    // connection store timeout
    // 60000    1 min
    // 300000   5 min
    // 600000  10 min
    // 900000  15 min
    // 1800000 30 min    
    public static final String TIMEOUT_STORE  = "300000";
    
    
    // max number of emails in the inbox cache
    public static final int MAX_INBOX_EMAIL_NUMBER  = 100;
    // max number of sent folder emails 
    public static final int MAX_SENT_EMAIL_NUMBER  = 20;
    
    // polling time for the cache (u.m. minutes)
    public static final int POLLING_INTERVALL = 10;
    
    // protocols
    public static final String PROTOCOL_IMAP = "imap";
    public static final String PROTOCOL_POP3 = "pop3";

    //protocols default ports
    public static final int PROTOCOL_IMAP_PORT = 143;
    public static final int PROTOCOL_POP3_PORT = 110;

    //folder IDs
    public static final String FOLDER_ROOT_ID   = "ROOT";
    public static final String FOLDER_INBOX_ID  = "I";
    public static final String FOLDER_OUTBOX_ID = "O";
    public static final String FOLDER_SENT_ID   = "S";
    public static final String FOLDER_DRAFTS_ID = "D";
    public static final String FOLDER_TRASH_ID  = "T";

    //folder GUIDs
    public static final String FOLDER_ROOT_GUID = "ROOT";
    public static final String FOLDER_INBOX_GUID = 
            FOLDER_ROOT_ID + SEPARATOR_FIRST + FOLDER_INBOX_ID;
    public static final String FOLDER_OUTBOX_GUID = 
            FOLDER_ROOT_ID + SEPARATOR_FIRST + FOLDER_OUTBOX_ID;
    public static final String FOLDER_SENT_GUID = 
            FOLDER_ROOT_ID + SEPARATOR_FIRST + FOLDER_SENT_ID;
    public static final String FOLDER_DRAFTS_GUID = 
            FOLDER_ROOT_ID + SEPARATOR_FIRST + FOLDER_DRAFTS_ID;
    public static final String FOLDER_TRASH_GUID = 
            FOLDER_ROOT_ID + SEPARATOR_FIRST + FOLDER_TRASH_ID;

    //default folder names
    public static final String FOLDER_ROOT_ENG   = "";
    public static final String FOLDER_INBOX_ENG  = "Inbox";
    public static final String FOLDER_OUTBOX_ENG = "Outbox";
    public static final String FOLDER_SENT_ENG_EXC = "Sent Items"; // Exchange
    public static final String FOLDER_SENT_ENG     = "Sent";
    public static final String FOLDER_DRAFTS_ENG = "Drafts";
    public static final String FOLDER_TRASH_ENG_EXC = "Deleted Items"; // Exchange
    public static final String FOLDER_TRASH_ENG     = "Trash"; 


    //folder roles
    public static final String FOLDER_INBOX_ROLE  = "inbox";
    public static final String FOLDER_OUTBOX_ROLE = "outbox";
    public static final String FOLDER_SENT_ROLE   = "sent";
    public static final String FOLDER_DRAFTS_ROLE = "drafts";
    public static final String FOLDER_TRASH_ROLE  = "deleted";

    //NOKIA folder names
    public static final String NOKIA_INBOX_ENG  = "Remote Inbox";
    public static final String NOKIA_OUTBOX_ENG = "Remote Outbox";
    public static final String NOKIA_SENT_ENG   = "Remote Sent";
    public static final String NOKIA_DRAFTS_ENG = "Remote Drafts";


    // filter
    public static final String FILTER_TYPE_INC   = "inclusive";
    public static final String FILTER_TYPE_EXC   = "exclusive";
    // time filter field
    public static final String FILTER_TIME_FIELD = "modified";
    // id filter field
    public static final String FILTER_ID_FIELD   = "LUID";
    // size filter field
    public static final String FILTER_SIZE_LABEL_HEADER = "emailitem";
    public static final String FILTER_SIZE_LABEL_BODY   = "texttype";
    public static final String FILTER_SIZE_LABEL_ATTACH = "attachtype";
    // size filter values
    //  0 0 0 0 0 1 = 1   FILTER_SIZE_H         (get only header)
    //  0 0 0 1 0 1 = 5   FILTER_SIZE_H_B       (get header and body)
    //  0 0 1 1 1 1 = 15  FILTER_SIZE_H_BPERC
    //  0 1 0 1 0 1 = 21  FILTER_SIZE_H_B_A     (get all message)
    //  1 1 1 1 1 1 = 63  FILTER_SIZE_H_B_APERC
    public static final int FILTER_SIZE_H          = 1;
    public static final int FILTER_SIZE_H_B        = 5;
    public static final int FILTER_SIZE_H_B_PERC   = 15;
    public static final int FILTER_SIZE_H_B_A      = 21;
    public static final int FILTER_SIZE_H_B_A_PERC = 63;
    // folder filter values
    //  0 0 0 0 1 -->  1  inbox
    //  0 0 0 1 1 -->  3  inbox + outbox
    //  0 0 1 1 1 -->  7  inbox + outbox + sent
    //  0 1 1 1 1 -->  15 inbox + outbox + sent + draft
    //  1 1 1 1 1 -->  31 inbox + outbox + sent + draft + trash
    public static final int FILTER_FOLDER_I     = 1;
    public static final int FILTER_FOLDER_IO    = 3;
    public static final int FILTER_FOLDER_IOS   = 7;
    public static final int FILTER_FOLDER_IOSD  = 15;
    public static final int FILTER_FOLDER_IOSDT = 31;

    // Header label
    public static final String HEADER_MESSAGE_ID   = "Message-ID";
    public static final String HEADER_RECEIVED     = "Received";
    public static final String HEADER_DATE         = "Date";
    public static final String HEADER_FROM         = "From";
    public static final String HEADER_TO           = "To";
    public static final String HEADER_REPLY_TO     = "Reply-To";
    public static final String HEADER_CC           = "CC";    
    public static final String HEADER_BCC          = "BCC";        
    public static final String HEADER_SUBJECT      = "Subject";
    public static final String HEADER_MIME         = "MIME-Version";
    public static final String HEADER_CONTENT_TYPE = "Content-Type";
    public static final String HEADER_CHARSET      = "charset";
    public static final String HEADER_SYNCMESSAGE  = "X-Funambol";
    public static final String HEADER_CONTENT_TRANSFERT_ENC = "Content-Transfer-Encoding";

    public static final String HEADER_VALUE_SYNCMESSAGE = "true";

    public static final String[] HEADER_MINIMUM   = {
                                                    HEADER_MESSAGE_ID,
                                                    HEADER_DATE,
                                                    HEADER_FROM,
                                                    HEADER_TO,
                                                    HEADER_SUBJECT,
                                                    HEADER_MIME,
                                                    HEADER_SYNCMESSAGE,
                                                    HEADER_REPLY_TO,
                                                    HEADER_CC,
                                                    HEADER_BCC
                                                    };
    
    // default Content for a mail
    public static final String CONTENT_BODY        = "";
    public static final String CONTENT_BODY_ALERT  = "Unsupported Encoding for Body Message";
    public static final String CONTENT_CONTENTTYPE = "text/plain; charset=UTF-8";
    public static final String CONTENT_CONTENTTYPE_CALENDAR = "text/calendar; charset=UTF-8";

    // message encoding types
    public static final String ENCODE_QUOTED_PRINTABLE = "quoted-printable";
    public static final String ENCODE_BASE64           = "base64";

    public static final String PWD_ENCODE_UTF8         = "UTF8";
    public static final String PWD_ALGORITHM           = "DESede";
    
    // server types
    public static final String SERVER_TYPE_EXCHANGE   = "Exchange";
    public static final String SERVER_TYPE_COURIER    = "Courier";
    public static final String SERVER_TYPE_GMAIL      = "GMail";
    public static final String SERVER_TYPE_OTHER      = "Other";    
 
    
    public static final String SIGNATURE =
            "funambol :: mobile open source :: http://www.funambol.com";    
    
    //
    // error code for the mail server connection
    // ok                           = 0
    // invalid protocol             = 1
    // invalid username or password = 2
    // cannection failed            = 3
    public static final int ERR_OK                  = 0;
    public static final int ERR_INVALID_PROTOCOL    = 1;
    public static final int ERR_INVALID_CREDENTIALS = 2;
    public static final int ERR_CONNECTION_FAILED   = 3;
    public static final int ERR_INVALID_INPUT       = 4;
    public static final int ERR_INVALID_DOMAIN      = 5;
    public static final int ERR_GENERIC_MAILSERVER  = 6;
    
    //
    // error filtering email
    public static final String ERR_FILTERING_EMAIL   = "Error Getting/Filtering Email";
    //
    // error code for the mail server deletion     
    public static final int ERR_SERVER_DELETION = -20;    
    
}
