/**
 * Copyright (C) 2005-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.util;


/**
 * @version $Id: Query.java,v 1.31 2007/03/19 08:48:40 gbmiglia Exp $
 */
public class Query {

  /**
   *
   */ 
  public static final String CACHE_SELECT_ITEMS_BY_PRINCIPAL_BY_SOURCE =
        "select guid, last_crc, invalid, internal, messageid, " +
        " headerdate, received, subject, sender, isemail" +
        " from fnbl_email_cache where source_uri = ? and principal = ?";

  /**
   *
   */ 
  public static final String CACHE_SELECT_INVALID_ITEMS =
        "select guid, last_crc, invalid, internal, messageid, " +
        " headerdate, received, subject, sender, isemail " +
        " from fnbl_email_cache where source_uri = ? and principal = ? and invalid = 'Y' ";  
  
  /**
   *
   */ 
  public static final String CACHE_ADD_LOCAL_ITEM  =
        "insert into fnbl_email_cache " +
        "(guid, last_crc, invalid, internal, source_uri, principal, " +
        " messageid, headerdate, received, subject, sender, isemail) " + 
        " values(?,?,?,?,?,?,?,?,?,?,?,?)";

  /**
   *
   */ 
  public static final String CACHE_DELETE_LOCAL_ITEMS  =
        "delete from fnbl_email_cache " +
        " where source_uri = ? and principal = ? ";
  
  /**
   *
   */ 
  public static final String SENT_DELETE_POP  =
        "delete from fnbl_email_sentpop " +
        " where source_uri = ? and principal = ?";

  /**
   *
   */ 
  public static final String SENT_SELECT_TWIN_SENT = 
            "select id, mail from fnbl_email_sentpop " +
            " where messageid = ? and source_uri = ? and principal = ?";
    
  /**
   * invalid item in cache query
   */ 
  public static final String CACHE_INVALID_ITEM  =
        "update fnbl_email_cache set invalid = 'Y' " + 
            " where guid = ?  and source_uri = ? and principal = ?";                                                   ;
    
  /** 
   * folders queries  
   */
  public static final String FOLDER_INSERT_FOLDER = 
            "insert into fnbl_email_folder " +
            "(guid, parentid, source_uri, principal, path) values (?,?,?,?,?)";

  /**
   *
   */ 
  public static final String FOLDER_DELETE_FOLDER = 
            "delete from fnbl_email_folder " +
            " where guid = ? and source_uri = ? and principal = ?";

  /**
   *
   */ 
  public static final String FOLDER_SELECT_FOLDER = 
            "select guid, parentid, path from fnbl_email_folder " +
            " where guid = ? and source_uri = ? and principal = ?";

  /**
   *
   */ 
  public static final String FOLDER_SELECT_FULLPATH = 
            "select path from fnbl_email_folder " +
            " where guid = ? and source_uri = ? and principal = ?";

  /**
   *
   */ 
  public static final String FOLDER_SELECT_FULLPATH_FROM_FID = 
            "select path from fnbl_email_folder " +
            " where guid like ? and source_uri = ? and principal = ?";

  /**
   *
   */ 
  public static final String FOLDER_SELECT_FOLDERID = 
            "select guid, parentid from fnbl_email_folder " +
            " where path = ? and source_uri = ? and principal = ?";

  /**
   *
   */ 
  public static final String FOLDER_SELECT_ALL_FOLDER = 
            "select guid, parentid, path from fnbl_email_folder " +
            " where source_uri = ? and principal = ?";

  /**
   * sent items queries
   */ 
  public static final String SENT_INSERT_SENT = 
            "insert into fnbl_email_sentpop " +
            " (id, source_uri, principal, mail, messageid) values (?,?,?,?,?)";

  /**
   *
   */ 
  public static final String SENT_DELETE_SENT = 
            "delete from fnbl_email_sentpop " +
            " where id = ? and source_uri = ? and principal = ?";

  /**
   *
   */ 
  public static final String SENT_SELECT_SENT = 
            "select mail from fnbl_email_sentpop " +
            " where id = ? and source_uri = ? and principal = ?";

  /**
   *
   */ 
  public static final String SENT_SELECT_ALL_SENT = 
            "select id from fnbl_email_sentpop " +
            " where source_uri = ? and principal = ? and id like ? ";
  
    
  /**
   *
   */
  public static final String INBOX_INSERT_MAILBOX_INFO =
        "insert into fnbl_email_inbox " +
        " (username, protocol, guid, last_crc, invalid, internal, messageid, " +
        "   headerdate, received, subject, sender, status) " +
        " values (?,?,?,?,?,?,?,?,?,?,?,?)";
     
  /**
   *
   */
  public static final String INBOX_UPDATE_CRC =
        "update fnbl_email_inbox set last_crc = ? " +
        "  where username = ? and protocol = ? and guid = ? ";
  
  /**
   *
   */
  public static final String INBOX_SELECT_ALL_MAILBOX_INFO =
        " select guid, last_crc, invalid, internal, messageid, " +
        " headerdate, received, subject, sender, status " + 
        " from fnbl_email_inbox where username = ? and protocol = ? " ;
  
  /**
   *
   */
  public static final String INBOX_SELECT_UNDELETED_MAILBOX_INFO =
        " select guid, last_crc, invalid, internal, messageid, " +
        " headerdate, received, subject, sender " + 
        " from fnbl_email_inbox where username = ? and protocol = ? and status <> 'D'" ;
  
  /**
   *
   */
  public static final String INBOX_SET_DELETED_STATUS =
        " update fnbl_email_inbox set status = 'D' " +
        " where  username = ? and protocol = ? and guid = ?" ;
  
  /**
   *
   */
  public static final String INBOX_REMOVE_DELETED_STATUS =
        " update fnbl_email_inbox set status = 'N' " +
        " where  username = ? and protocol = ? " ;
      
  /**
   *
   */
  public static final String INBOX_DELETE_EMAILS  =
          "delete from fnbl_email_inbox where username = ?";
  
  /**
   *
   */
  public static final String INBOX_DELETE_EMAIL  =
        "delete from fnbl_email_inbox where username = ? and protocol = ? and  guid = ? ";
    
  /**
   *
   */ 
  public static final String INBOX_SELECT_INFO_4_ADMIN =
        "select guid, messageid, headerdate, received, subject from fnbl_email_inbox " +
        " where username = ? and protocol = ? " +
        " order by headerdate desc ";
  
  /**
   *
   */
  public static final String MS_LIST_MAILSERVER  = 
    "select mailserver_id, server_type, description, protocol, out_server, out_port," +
    " out_auth, in_server, in_port, sslin, sslout, keystore_path, keystore_pwd, " +
    " inbox_name, inbox_active, outbox_name, outbox_active, sent_name, sent_active, " +
    " drafts_name, drafts_active, trash_name, trash_active, soft_delete, server_public " +
    " from fnbl_email_mailserver";
  
  /**
   *
   */
  public static final String MS_GET_MAILSERVER  = 
    "select mailserver_id, server_type, description, protocol, out_server, out_port," +
    " out_auth, in_server, in_port, sslin, sslout, keystore_path, keystore_pwd, " +
    " inbox_name, inbox_active, outbox_name, outbox_active, sent_name, sent_active, " +
    " drafts_name, drafts_active, trash_name, trash_active, soft_delete, server_public " +
    " from fnbl_email_mailserver where mailserver_id = ?";
  
  /**
   *
   */
  public static final String MS_INSERT_MAILSERVER  = 
    "insert into fnbl_email_mailserver (mailserver_id, server_type, description, protocol, " +
    "  out_server, out_port, out_auth, in_server, in_port, sslin, sslout, keystore_path, keystore_pwd, " +
    "  inbox_name,inbox_active, outbox_name,outbox_active, sent_name, sent_active, " +
    "  drafts_name, drafts_active, trash_name, trash_active, soft_delete, server_public) " +
    "values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?) " ; 
  
  /**
   *
   */
  public static final String MS_UPDATE_MAILSERVER  = 
    "update fnbl_email_mailserver set server_type=?, description=?, protocol=?, " +
    "  out_server=?, out_port=?, out_auth=?, in_server=?, in_port=?, " +
    "  sslin=?, sslout=?, keystore_path=?, keystore_pwd=?, " +
    "  inbox_name=?,inbox_active=?, outbox_name=?,outbox_active=?, " +
    "  sent_name=?, sent_active=?, drafts_name=?, drafts_active=?, " +
    "  trash_name=?, trash_active=?, soft_delete=?, server_public=? where mailserver_id = ? "; 
  
  /**
   *
   */
  public static final String MS_DELETE_MAILSERVER  = 
    "delete from fnbl_email_mailserver where mailserver_id = ? "; 
  
  /**
   *
   */
  public static final String MS_ACCOUNT_LIST_USER  = 
    "select account_id, username, ms_login, ms_password, ms_address," +
    " listener_id, activation, push," +
    " refresh_time, max_num_email, max_imap_email," +
    " mailserver_id, server_type, description, protocol, " +
    " out_server, out_port, out_auth, in_server, in_port, " +
    " sslin, sslout, keystore_path, keystore_pwd, inbox_name, inbox_active, " +
    " outbox_name, outbox_active, sent_name, sent_active, " +
    " drafts_name, drafts_active, trash_name, trash_active, " +
    " soft_delete, server_public from fnbl_email_account " ;    
  
  
  /**
   * NOTE: this query uses the table 'fnbl_user'. 
   * this table is a DS-Server table.
   */
  public static final String MS_ACCOUNT_TO_REMOVE  = 
   "select account_id, username from fnbl_email_account where username " +
   " not in  (select username from fnbl_user)";
   
  /**
   *
   */
  public static final String MS_ACCOUNT_CHECK_USER  = 
    "select count(*) from fnbl_email_account where mailserver_id = ?" ;    
  
  
  /**
   *
   */
  public static final String MS_ACCOUNT_SELECT_ACCOUNT_TO_REMOVE  = 
     "select account_id, username from fnbl_email_account " +
     " where username not in (select username from fnbl_user) and listener_id = ?";
  
  /**
   *
   */
  public static final String MS_ACCOUNT_GET_USER  = 
    "select account_id, username, ms_login, ms_password, ms_address, " +
    " listener_id, activation, push," +
    " refresh_time, max_num_email, max_imap_email, " +
    " mailserver_id, server_type, description, protocol, " +
    " out_server, out_port, out_auth, in_server, in_port, " +
    " sslin, sslout, keystore_path, keystore_pwd, inbox_name, inbox_active, " +
    " outbox_name, outbox_active, sent_name, sent_active, " +
    " drafts_name, drafts_active, trash_name, trash_active, " +
    " soft_delete, server_public from fnbl_email_account where account_id = ?" ;
  
  /**
   *
   */
  public static final String MS_ACCOUNT_GET_USER_ID  = 
    "select account_id from fnbl_email_enable_account where username = ?" ;
  
  /**
   *
   */
  public static final String MS_ACCOUNT_GET_USER_NAME  = 
    "select username from fnbl_email_enable_account where account_id = ?" ;
  
  
  /**
   *
   */
  public static final String MS_ACCOUNT_GET_USERS_FROM_LISTENER =
    "select account_id, username, ms_login, ms_password, ms_address, " +
    " listener_id, activation, push," +
    " refresh_time, max_num_email, max_imap_email, " +
    " mailserver_id, server_type, description, protocol, " +
    " out_server, out_port, out_auth, in_server, in_port, " +
    " sslin, sslout, keystore_path, keystore_pwd, inbox_name, inbox_active, " +
    " outbox_name, outbox_active, sent_name, sent_active, " +
    " drafts_name, drafts_active, trash_name, trash_active, " +
    " soft_delete, server_public " +
    " from fnbl_email_account where listener_id = ? and activation = ? ";
    
  /**
   *
   */
  public static final String MS_ACCOUNT_INSERT_USER  = 
    "insert into fnbl_email_account (" +
    " account_id, username, ms_login, ms_password, ms_address," +
    " listener_id, activation, push, " +
    " refresh_time, max_num_email, max_imap_email," +
    " mailserver_id, server_type, description, protocol, " +
    " out_server, out_port, out_auth, in_server, in_port, " +
    " sslin, sslout, keystore_path, keystore_pwd, " +
    " inbox_name, inbox_active, outbox_name, outbox_active, sent_name, sent_active, " +
    " drafts_name, drafts_active, trash_name, trash_active, soft_delete, server_public) " +
    " values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?) " ; 
  
  /**
   *
   */
  public static final String MS_ACCOUNT_ENABLER = 
    "insert into fnbl_email_enable_account (account_id, username) values (?,?)"; 
  
  /**
   *
   */
  public static final String MS_ACCOUNT_UPDATE_USER  = 
    "update fnbl_email_account set " +
    " ms_login=?, ms_password=?, ms_address=?," +
    " listener_id=?, activation=?, push=?, refresh_time=?, " +
    " max_num_email=?, max_imap_email=?, " +
    " mailserver_id=?, server_type=?, description=?, protocol=?, " +
    " out_server=?, out_port=?, out_auth=?, in_server=?, in_port=?, " +
    " sslin=?, sslout=?, keystore_path=?, keystore_pwd=?, " +
    " inbox_name=?, inbox_active=?, outbox_name=?, outbox_active=?, sent_name=?, sent_active=?, " +
    " drafts_name=?, drafts_active=?, trash_name=?, trash_active=?, soft_delete=?, server_public=? " +
    " where account_id = ? and username = ?" ; 
  

  /**
   *
   */
  public static final String MS_ACCOUNT_UPDATE_MAILSERVER_4_USERS  = 
    "update fnbl_email_account set " +
    " server_type=?, description=?, protocol=?, " +
    " out_server=?, out_port=?, out_auth=?, in_server=?, in_port=?, " +
    " sslin=?, sslout=?, keystore_path=?, keystore_pwd=?, soft_delete=?, server_public=? " +
    " where mailserver_id = ? " ; 
  
  
  /**
   *
   */
  public static final String MS_ACCOUNT_DELETE_USER  = 
    "delete from fnbl_email_account where account_id = ? " ; 
  
  /**
   *
   */
  public static final String MS_ACCOUNT_DISABLE_USER  = 
    "update fnbl_email_account set activation = 'n' where account_id = ?" ; 
  
  /**
   *
   */
  public static final String MS_ACCOUNT_ENABLE_USER  = 
    "update fnbl_email_account set activation = 'y' where account_id = ?" ; 
  
  /**
   *
   */
  public static final String MS_ACCOUNT_DELETE_ENABLE_USER  = 
    "delete from fnbl_email_enable_account where account_id = ? " ; 
  
}
