/**
 * Copyright (C) 2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.util;

import java.awt.*;
import java.awt.event.WindowEvent;

/**
 * NOTE: used for testing purpose
 *
 * @version $Id: ShowString.java,v 1.1 2007/03/07 14:44:00 gbmiglia Exp $
 */
public class ShowString extends Frame {

    FontMetrics fontM;
    String outString;
    
    public ShowString (String target, String title) {
        
       this.addWindowListener(new java.awt.event.WindowAdapter() {
                                public void windowClosing(WindowEvent e) {
                                  frame_windowClosing(e);
                                }
                              }
                          );
                          
        setTitle(title);
        outString = target;

        Font font = new Font("Monospaced", Font.PLAIN, 36);
        fontM = getFontMetrics(font);
        setFont(font);

        int size = 0;
        for (int i = 0; i < outString.length(); i++) {
           size += fontM.charWidth(outString.charAt(i));
        }
        size += 24;

        setSize(size, fontM.getHeight() + 60);
        setLocation(getSize().width/2, getSize().height/2);
        setVisible(true);
    }

    public void paint(Graphics g) {
        Insets insets = getInsets();
        int x = insets.left; 
        int y = insets.top;
        g.drawString(outString, x + 6, y + fontM.getAscent() + 14);
    }
    
    public void frame_windowClosing(WindowEvent e) {
       System.exit(-1);
    }  
    
}
