/**
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.util;


import com.funambol.email.engine.source.EmailConnectorConfig;
import com.funambol.email.exception.InboxListenerConfigException;
import com.funambol.email.exception.InboxListenerException;
import com.funambol.email.inboxlistener.engine.WSTools;
import com.funambol.email.inboxlistener.engine.WSAccount;
import com.funambol.framework.tools.beans.BeanException;
import com.funambol.framework.tools.beans.BeanFactory;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * <p>InboxListener Utility class</p>
 *
 * @version $Id: UtilityIL.java,v 1.11 2007/03/08 11:45:03 gbmiglia Exp $
 */

public class UtilityIL {

  //------------------------------------------------------------------ CONSTANTS
    
    
  // ------------------------------------------------------------ Public Methods
    
  /**
   *
   */
  public static int readInteger() throws InboxListenerException {

    InputStreamReader iReader = new InputStreamReader(System.in);
    BufferedReader indata     = new BufferedReader(iReader);

    int    value = -1;
    String temp  = null;
    try {
       temp = indata.readLine();
       value = Integer.parseInt(temp);
    } catch (IOException ex) {
       throw new InboxListenerException("Error reading input value (" +
                                         ex.getMessage() + ")");
    } catch (NumberFormatException ex) {
       throw new InboxListenerException("Error converting input value (" +
                                         ex.getMessage() + ")");
    }

    return value;
  }
  
  /**
   *
   */
  public static String readValue() throws InboxListenerException {

    InputStreamReader iReader = new InputStreamReader(System.in);
    BufferedReader indata     = new BufferedReader(iReader);
    String value  = null;
    try {
       value = indata.readLine();
    } catch (IOException ex) {
       throw new InboxListenerException("Error reading input value (" +
                                         ex.getMessage() + ")");
    }
    return value;
  }  
  
  
  /**
   * used in the ListenerRegistry
   * the reloading_time in the XML file is in minute format. 
   * but we have to convert in millisec 
   */
  public static int setMilliSecondsFromMinutes(int minutes) {
      int msecs = 600000; // default 10 minutes
      msecs = ((minutes * 60) * 1000);
      return msecs;
  } 
  
  /**
   * used in the ListenerRegistryDAO
   * the refresh_time in the DB is in second format. 
   * but we have to convert in millisec 
   */
  public static int setMilliSecondsFromSeconds(int seconds) {
      int msecs = 600000; // default 10 minutes
      msecs = seconds * 1000;
      return msecs;
  } 
  
      
}
