--
-- Initialization data for the Email Connector module
--
-- @version $Id: init_schema.sql,v 1.22 2007/02/05 13:29:27 gbmiglia Exp $ 
--

--
-- Source registration
--

delete from fnbl_sync_source_type where id='email-ss';
insert into fnbl_sync_source_type(id, description, class, admin_class) values('email-ss','Email SyncSource','com.funambol.email.engine.source.EmailSyncSource','com.funambol.email.admin.EmailSyncSourceConfigPanel');

delete from fnbl_module where id='email';
insert into fnbl_module (id, name, description) values('email','email','email');

delete from fnbl_connector where id='email';
insert into fnbl_connector(id, name, description, admin_class) values('email','FunambolEmailConnector','Funambol Email Connector','com.funambol.email.admin.ConsolePanel');

delete from fnbl_connector_source_type where connector='email' and sourcetype='email-ss';
insert into fnbl_connector_source_type(connector, sourcetype) values('email','email-ss');

delete from fnbl_module_connector where module='email' and connector='email';
insert into fnbl_module_connector(module, connector) values('email','email');

--
--  SyncSource
--

delete from fnbl_client_mapping where sync_source='mail';

delete from fnbl_last_sync where sync_source='mail';

delete from fnbl_sync_source where uri='mail';
insert into fnbl_sync_source (uri, config, name, sourcetype)
  values('mail', 'email/email/email-ss/mail.xml','mail','email-ss');


--
-- public mail server
--

insert into fnbl_email_mailserver (mailserver_id, server_public, server_type, description, protocol, 
  out_server, out_port, out_auth, in_server, in_port, sslin, sslout, keystore_path, keystore_pwd, 
  inbox_name,inbox_active, outbox_name,outbox_active, sent_name, sent_active,
  drafts_name, drafts_active, trash_name, trash_active, soft_delete)    
values ('1', 'y', 'GMail', 'GMail', 'pop3', 'smtp.gmail.com', 465, 'y', 'pop.gmail.com', 995, 
        'y', 'y', 'gmail.keystore', 'funambol',
        'Inbox', 'y', 'Outbox', 'y', 'Sent', 'n', 'Drafts', 'n', 'Trash', 'n', 'y');

insert into fnbl_email_mailserver (mailserver_id, server_public, server_type, description, protocol, 
  out_server, out_port, out_auth, in_server, in_port, sslin, sslout, keystore_path, keystore_pwd, 
  inbox_name,inbox_active, outbox_name,outbox_active, sent_name, sent_active,
  drafts_name, drafts_active, trash_name, trash_active, soft_delete)
values ('2', 'y', 'Other', 'Yahoo', 'pop3', 'smtp.mail.yahoo.com', 587, 'y', 'pop.mail.yahoo.com', 110, 
        'n', 'n', null, null,
        'Inbox', 'y', 'Outbox', 'y', 'Sent', 'n', 'Drafts', 'n', 'Trash', 'n', 'n');

insert into fnbl_email_mailserver (mailserver_id, server_public, server_type, description, protocol, 
  out_server, out_port, out_auth, in_server, in_port, sslin, sslout, keystore_path, keystore_pwd, 
  inbox_name,inbox_active, outbox_name,outbox_active, sent_name, sent_active,
  drafts_name, drafts_active, trash_name, trash_active, soft_delete)
values ('3', 'y', 'Other', 'HotMail', 'pop3', 'smtp.hotmail.com', 25, 'n', 'pop.hotmail.com', 110, 
        'n', 'n', null, null,
        'Inbox', 'y', 'Outbox', 'y', 'Sent', 'n', 'Drafts', 'n', 'Trash', 'n', 'n');

--
-- id for sent emails
--

delete from fnbl_id where idspace='email.cacheid';
delete from fnbl_id where idspace='email.sentid';
delete from fnbl_id where idspace='email.folderid';
delete from fnbl_id where idspace='email.mailserverid';
delete from fnbl_id where idspace='email.userid';
insert into fnbl_id (idspace, counter) values('email.cacheid',0);
insert into fnbl_id (idspace, counter) values('email.sentid',0);
insert into fnbl_id (idspace, counter) values('email.folderid',0);
insert into fnbl_id (idspace, counter) values('email.mailserverid',100);
insert into fnbl_id (idspace, counter) values('email.userid',0);
