--
-- Initialization data for the Email Connector module
--
-- @version $Id: create_schema.sql,v 1.31 2007/03/08 13:26:38 gbmiglia Exp $
--

-- tables for the caching system

create table fnbl_email_cache (
    guid       varchar(200) not null,
    source_uri varchar(128) not null,
    principal  integer      not null,
    last_crc   bigint,
    invalid    char, 
    internal   char,    
    messageid  varchar(200),
    headerdate varchar(20),
    received   varchar(20),
    subject    varchar(700),
    sender     varchar(300),
    isemail    char,    
    constraint pk_cache primary key (guid, source_uri, principal)        
);

create table fnbl_email_inbox (
    guid        varchar(200) not null,
    username    varchar(50)  not null,
    protocol    varchar(4)   not null,
    last_crc    bigint,
    invalid     char, 
    internal    char,    
    messageid   varchar(200),
    headerdate  varchar(20),   
    received    varchar(20),
    subject     varchar(700),
    sender      varchar(300),
    status      char,    
    constraint pk_cache_inbox primary key (guid, username, protocol)        
);

-- tables folder guids

create table fnbl_email_folder (
    guid       varchar(50)  not null,
    source_uri varchar(128) not null,
    principal  integer      not null,
    parentid   varchar(50),
    path       varchar(500),
    constraint pk_folder primary key (guid, source_uri, principal)        
);

-- tables for POP connector

create table fnbl_email_sentpop (
    id         varchar(200) not null,
    source_uri varchar(128) not null,
    principal  integer      not null,
    messageid  varchar(200),
    mail       bytea,
    constraint pk_sentpop primary key (id, source_uri, principal)            
);

-- V6 tables

create table fnbl_email_enable_account (
    account_id    varchar(20)  not null,
    username      varchar(50)  not null,
    constraint pk_enable_account primary key (account_id, username)        
);

create table fnbl_email_account (
    account_id    varchar(20)  not null,
    username      varchar(50)  not null,
    ms_login      varchar(50)  not null,
    ms_password   varchar(50)  not null,
    ms_address    varchar(70)  not null,
    listener_id   varchar(20),
    activation    char,
    push          char,
    soft_delete   char,    
    refresh_time  integer,
    max_num_email integer,
    max_imap_email integer,
    mailserver_id varchar(20)  not null,
    server_public char,
    server_type   varchar(20),
    description   varchar(50),
    protocol      varchar(5),
    out_server    varchar(30),
    out_port      integer,
    out_auth      char,
    in_server     varchar(30),
    in_port       integer,
    sslin         char,
    sslout        char,
    keystore_path varchar(100),
    keystore_pwd  varchar(20),
    inbox_name    varchar(30),
    inbox_active  char,
    outbox_name   varchar(30),
    outbox_active char,
    sent_name     varchar(30),
    sent_active   char,
    drafts_name   varchar(30),
    drafts_active char,
    trash_name    varchar(30),
    trash_active  char,
    
    constraint pk_user_account primary key (account_id, username)
        
);

create table fnbl_email_mailserver (
    mailserver_id varchar(20)  not null,
    server_public char,
    server_type   varchar(20),
    description   varchar(50),
    protocol      varchar(5),
    out_server    varchar(30),
    out_port      integer,
    out_auth      char,
    in_server     varchar(30),
    in_port       integer,
    sslin         char,
    sslout        char,
    keystore_path varchar(100),
    keystore_pwd  varchar(20),
    inbox_name    varchar(30),
    inbox_active  char,
    outbox_name   varchar(30),
    outbox_active char,
    sent_name     varchar(30),
    sent_active   char,
    drafts_name   varchar(30),
    drafts_active char,
    trash_name    varchar(30),
    trash_active  char,
    soft_delete   char,    
    constraint pk_mailserver primary key (mailserver_id)
);
